<%@ page language="java" %>
<%@ page import="it.loway.tpf.*" %>
<%@ page import="it.loway.tpf.common.containers.*" %>
<%@ page import="it.loway.tpf.common.exceptions.*" %>
<%@ page import="it.loway.app.queuemetrics.*" %>
<%@ page import="it.loway.tpf.common.containers.LDecoder" %>
<%@ page import="it.loway.app.queuemetrics.html.WizardNavigationBar" %>
<%@ page import="it.loway.app.queuemetrics.jdbcTester.jdbcTester" %>
<%@ page import="it.loway.app.queuemetrics.jdbcTester.dbtestWizard" %>

<%@ include file="/includes/00_page_header_context.jspf" %>

<%
    // $Id: dbtestWizard5.jsp,v 1.3 2015/09/28 08:41:16 marcos Exp $

    // -- Showing the AGAW result during the database updater wizard --

    // Start the Wizard Navigation Bar
    oDec.load( "dbtest_wznavbar", "dbtest_wzNavBar.txt", 0, 1 );
    WizardNavigationBar wzNavBar = new WizardNavigationBar(oDec, "dbtest_wznavbar");

    boolean bSucceded = oC.getS("DBTEST_OperationStatus").equalsIgnoreCase("OK");
    boolean bResultPage = oC.getS("DBTEST_ImAResultPage").equalsIgnoreCase("YES");
    boolean showResults = bResultPage;

    // Define next step
    int nextHopID_Yes = dbtestWizard.STEP_CLEANUPAGAW_RESULT;
    int nextHopID_No = dbtestWizard.STEP_END;
    int nextHopID = dbtestWizard.STEP_END;
    if (!bSucceded)
        nextHopID = dbtestWizard.STEP_START;

    String nextHopYes = "dbtest_Wizard.do?StepID_" + Integer.toString(nextHopID_Yes);
    String nextHopNo = "dbtest_Wizard.do?StepID_" + Integer.toString(nextHopID_No);
    String nextHop = "dbtest_Wizard.do?StepID_" + Integer.toString(nextHopID);

    // Take results if required
    LTable ltDBTestResult = null;
    if (showResults)
        ltDBTestResult = oC.getLt("DBTEST_OperationResult");
%>

<%@ include file="dbupdateHeader.jsp" %>

<div id="bCorpo" class="qm-form-body L-column L-gap-24">
  <h1>JDBC connection tester</h1>

  <div id="bCorpo">
    <%=wzNavBar.RenderHTML(4)%><p/>
    <hr>
  </div>

  <div id="bCorpo">
    <% if (!bResultPage) { %>
        Do you want to perform an optimization of AGAW logs and tables?
    <% } else {
        if (bSucceded) { %>
            <div class="L-success">AGAW information optimized successfully.</div>
        <% } else { %>
            <div class="L-error">Some errors were found when optimizing AGAW tables.<div>
            <br>Please check the report below and report errors to Loway.
        <% } %>
    <% } %>
  </div>

  <div id="bCorpo">
    <form>
      <div class="L-row L-gap-16">
        <% if (!bResultPage) { %>
            <div class="L-row L-gap-16">
              <input class="Q-button-primary" onclick="window.location='<%=nextHopYes%>'" type=button value="Yes">
              <input class="Q-button-secondary" onclick="window.location='<%=nextHopNo%>'" type=button value="No">
            </div>
        <% } else { %>
            <div>
              <input class="Q-button-primary" onclick="window.location='<%=nextHop%>'" type=button value="Next >">
            </div>
        <% } %>
      </div>
    </form>
  </div>

  <% if (showResults) { %>
    <div id="bCorpo" class="L-column L-gap-24"> 
      Below you can find the performed check details:
      <div>
        <%
          SmartTable T = new SmartTable("x", ltDBTestResult);
          T.setDecoder(oDec);
          T.addColumn(oDec.k("td_dbtest_wz_operationname"), 0, "300");
          T.addColumn(oDec.k("td_dbtest_wz_operationtime"), 1, "80");
          T.withTableClass( "qm-table Q-table qm-table-striped L-width-100" );
          out.println(T.render());
        %>
      </div>
    </div>
  <% } %>
</div>

<%@ include file="dbupdateFooter.jsp" %>
