<%@ page language="java" %>
<%@ page import="it.loway.tpf.*" %>
<%@ page import="it.loway.tpf.common.containers.*" %>
<%@ page import="it.loway.tpf.common.interfaces.*" %>
<%@ page import="it.loway.tpf.common.exceptions.*" %>
<%@ page import="it.loway.tpf.presentation.html.*" %>
<%@ page import="it.loway.tpf.presentation.html.decorators.*" %>
<%@ page import="it.loway.app.queuemetrics.asterisk.manager.*" %>


<%
    String pageBundle = AssetManager.basicBundle(session, application, request);
%>
<%@ include file="/includes/00_page_header.jspf" %>

<%
    //$Id: mgr.jsp,v 1.6 2015/09/28 08:41:17 marcos Exp $
    //
%>
<script defer>
function onLoadApplicativo() {
	// transazione standard
	document.forms[0].<%= K.REQ_VERBO %>.value = "";
	document.forms[0].<%= K.REQ_PARAM %>.value = "";
        document.forms[0].action = "mgr.jsp";
        document.forms[0].method = "GET";

}
</script>


<%
    String stAstServer = request.getParameter("server");
    String stChannel   = request.getParameter("chan");
    String stVariable  = request.getParameter("var");

    if ( stAstServer == null ) {
        stAstServer = "tcp:dial:bingo@10.10.3.5:5038" ;
    }

    if ( stChannel == null ) {stChannel = ""; }
    if ( stVariable== null ) {stVariable= ""; }

%>

		<div class="qm-form-body L-column L-gap-24">
			<h2>Querying an Asterisk server through the manager API</h2>
			<div class="L-row L-gap-24 L-align-flexend">
        <div class="L-column L-gap-8 L-width-25">
          <label for="">Asterisk server</label>
          <div><input type="text" name="server" value="<%= stAstServer %>" ></div>
        </div>

        <div class="L-column L-gap-8 L-width-25">
          <label for="">Channel</label>
          <div><input type="text" name="chan" value="<%= stChannel%>" ></div>
        </div>

        <div class="L-column L-gap-8 L-width-25">
          <label for="">Variable</label>
          <div><input type="text" name="var" value="<%= stVariable%>" ></div>
        </div>

        <div class="">
          <input type="hidden" name="rnd"    value="<%= U.getRandomString(9) %>">
          <input type="submit" class="Q-button-primary" value="Run">
        </div>
			</div>

    <hr>

    <%
        if ( stAstServer.length() > 0   ) {
            AstManager a = new AstManager();
            try {

                a.connectFromUri( stAstServer );
                out.println( "<br>Querying server" + stAstServer + "<br>");

                a.sendCommand( MgrAction.QueueStatus() );
                //out.println("<h1>Queue Status</h1><pre>" + a.getResponse() + "</pre><hr>");
                out.println( a.getBlockAsHtml( "QueueParams" ) );
                out.println( a.getBlockAsHtml( "QueueMember" ) );
                out.println( a.getBlockAsHtml( "QueueEntry" ) );


                a.sendCommand( MgrAction.Agents() );
                //out.println("<h1>Agents</h1><pre>" + a.getResponse() + "</pre><hr>");
                out.println( a.getBlockAsHtml( "Agents" ) );

                a.sendCommand( MgrAction.Status() );
                //out.println("<h1>Status</h1><pre>" + a.getResponse() + "</pre><hr>");
                out.println( a.getBlockAsHtml( "Status" ) );

                if ( !stAstServer.startsWith("file") ) {
                    a.sendCommand( MgrAction.Queues() );
                    out.println("<h1>Queues</h1><pre>" + a.getResponse() + "</pre><hr>");
                }

                if ( (stChannel.length() > 0)  && ( stVariable.length() > 0 )  ) {
                    String stRes = a.readVar( stChannel, stVariable );
                    out.println( "<font color='red'>");
                    out.println( "Querying variable " + stVariable + " on channel " + stChannel +"");
                    out.println( " - value: '<b>" + stRes + "</b>'" );
                    out.println( "</font>");

                }

        //            MgrAction m = MgrAction.Originate( "Local/12@queuemetrics/n", "10", "queuemetrics", "", "");
        //            m.addVar( "QM_AGENT", "103");
        //            a.sendCommand( m );

                a.sendCommand( MgrAction.LogOff() );
                a.disconnect();
            } catch ( TechException e ) {
                out.println( "<div class='L-column L-gap-8'>");
                out.println( "<h3>Error</h3>");
                out.println( "<pre>" + U.stringifyException(e) + "</pre>" );
                out.println( "</div>");

            }
        }
    %>
</div>

<%@ include file="/includes/00_page_footer.jspf" %>
