<%@ page language="java" %>
<%@ page import="it.loway.tpf.*" %>
<%@ page import="it.loway.tpf.common.containers.*" %>
<%@ page import="it.loway.tpf.common.debug.*" %>
<%@ page import="it.loway.tpf.common.interfaces.*" %>
<%@ page import="it.loway.tpf.common.exceptions.*" %>
<%@ page import="it.loway.tpf.presentation.html.*" %>
<%@ page import="it.loway.tpf.presentation.html.decorators.*" %>
<%@ page import="it.loway.app.queuemetrics.html.NoCache" %>
<%@ page import="it.loway.app.queuemetrics.html.AssetManager" %>
<%@ page import="it.loway.app.queuemetrics.*" %>
<%@ page import="it.loway.app.queuemetrics.caricamento.*" %>
<%@ page import="it.loway.app.queuemetrics.asterisk.logs.*" %>
<%@ page import="it.loway.app.queuemetrics.callListen.listeners.PluggableListener" %>
<%@ page import="it.loway.app.queuemetrics.smartTableDecorators.IconLib" %>
<%@ page import="it.loway.app.queuemetrics.html.QAItemTypeHandler" %>
<%@ page import="it.loway.app.queuemetrics.configurazione.QAFormInfo" %>
<%@ page import="it.loway.app.queuemetrics.configurazione.QAFormData" %>
<%@ page import="it.loway.app.queuemetrics.tasks.transactions.SearchTasksForQAPopup" %>
<%@ page import="java.text.*" %>
<%@ page contentType="text/html;charset=UTF-8"%>
<%@ page pageEncoding="UTF-8"%>
<%
class qaCodeDecor implements TpfCellDecoratorInterface {

           public String decorate(LTable lt, int r, int c, String width) throws TechException {
            String stTesto     = lt.getS(r, c );
            String stID = "id='QAE_div_code_" + stTesto + "'";

            return  "  <td class='stData' " + stID + " style='width: " + width + ";'>" + stTesto + "</td>\n";
        }
};

class sectionTitleExtractor {

    private String[] titles;

    public void init(LTable lt) {

        int titNum = 0;
        titles = new String[QAFormInfo.MAX_SECTIONS];
        for (int row = 0; row < lt.numRows(); row++) {

            String title = lt.getS(row,0);
            if (title.length() == 0)
                continue;

            if (title.length() > 15)
                title = title.substring(0, 15) + "...";

            titles[titNum] = title;
            titNum++;
        }
    }

    public String getSectionTitle(int sectionNum) {

        if (sectionNum > QAFormInfo.MAX_SECTIONS)
            return "";

        String title = titles[sectionNum];
        if (title == null)
            return "";

        return title;
    }
}

class qaTitleDecor implements TpfCellDecoratorInterface {
        public String decorate(LTable lt, int r, int c, String width) throws TechException {
            String stTesto     = lt.getS(r, c );
            String stTestoTit  = lt.getS(r, 0 );
            String stItem = lt.getS(r, 1 );
            String stID = "";

            if ( stTestoTit.length() > 0 ) {
                stTesto = "<b>" + stTestoTit + "</b>";
            } else if (stItem.length() > 0) {
                stID = "id='QAE_div_text_" + stItem + "'";
            }

            return  "  <td class='stData' " + stID + " style='width: " + width + ";'>" + stTesto + "</td>\n";
        }
};

class qaStatusDecor implements TpfCellDecoratorInterface {
        public String decorate(LTable lt, int r, int c, String width) throws TechException {
            String stItem      = lt.getS(r, c );
            String stEntry     = "&nbsp;";
            if ( stItem.length() > 0 ) {
                stEntry = "<div id='QAE_div_" + stItem + "'> &nbsp; </div>";
            }
            return  "  <td class='stData' style='width: " + width + ";'>" + stEntry  + "</td>\n";
        }
};

class qaMandatoryDecor implements TpfCellDecoratorInterface {

    private HtmlGenerator oH;
    private boolean isInputMode;
    private int itemCodeCol;
    private int itemMandatoryCol;

    public qaMandatoryDecor(HtmlGenerator oH, boolean isInputMode, int itemCodeCol, int itemMandatoryCol) {
        this.oH = oH;
        this.isInputMode = isInputMode;
        this.itemCodeCol = itemCodeCol;
        this.itemMandatoryCol = itemMandatoryCol;
    }

    public String decorate(LTable lt, int r, int c, String width) throws TechException {

        String stEntry = "&nbsp;";
        String itemCode = lt.getS(r, itemCodeCol);
        if (itemCode.length() == 0)
            return "<td class='stData' style='width: " + width + ";'>" + stEntry + "</td>\n";

        if (isInputMode) {
            boolean isMandatoryField = (lt.getI(r, itemMandatoryCol) != 0)? true : false;
            String checked = (lt.getI(r,c) != 0)? " checked ":"";
            if (!isMandatoryField)
                stEntry = "<input id=\"QAE_item_mdty_" + itemCode + "\" name=\"QAE_item_mdty_" + itemCode + "\" type=\"checkbox\" " + checked +" onclick=\"javascript:recount()\" />";
        }

        return "<td class='stData' style='width: " + width + ";'>" + stEntry + "</td>\n";
    }
};

class qaItemCommentsHandler implements TpfCellDecoratorInterface {

    private LDecoder oDec;

    public qaItemCommentsHandler(LDecoder oDec) {
        this.oDec = oDec;
    }

    public String decorate(LTable lt, int r, int c, String width) throws TechException {

        String itemCode = lt.getS(r, c);

        if (itemCode.length() == 0) {
            return "<td class=\"stData\"></td>";
        }

        // <td class="stData" id="QAE_div_comments_S1I2" style="align: center;" onClick="javascript:openCommentDialog('S1I2')" title="Click here to enter a note"><img id="QAE_icon_comments_S1I2" src="popup_qa_grade_ajx.jsp_files/information.png" style="display: none;"/></td>

        return "<td class=\"stData\"> " +
                "<div class='qm-pointer' id=\"QAE_div_comments_" + itemCode + "\" onClick=\"javascript:openCommentDialog('" + itemCode + "')\" title=\"" + oDec.k("qa_itemcomment_title") + "\">" +
                "<img id=\"QAE_icon_comments_" + itemCode + "\" src=\".." + IconLib.I_QA_ITMNOTEPRES + "\" style=\"display: none;\"/>" +
                "<img id=\"QAE_icon_addcomments_" + itemCode + "\" src=\".." + IconLib.I_QA_ADDITMNOTE + "\" style=\"display: block;\"/>" +
                "</div>"+
                "</td>";
    }
}
%>

<%
        LContext oC = (LContext) session.getAttribute( K.SESSION_CONTESTO );
        if ( oC == null ) {
           response.sendRedirect( "qm_start.do" );
           return;
        }

        LUser oU = (LUser) session.getAttribute( K.SESSION_USER );

        String stWebHere = Web.getWebApp( request );

        LDecoder oDec = (LDecoder) session.getAttribute( K.SESSION_DECODER );
        oDec.doLoadVista( "qa_form_status", "qa_form_status.txt", 0, 1 );

        // Ottiene il generatore di HTML
        HtmlGenerator oH = new HtmlGenerator( oC, oDec );

        // Retrieve form data
        LTable ltFormData = oC.getLt( "QAE_ltDat" );

        // modo della pagina
        boolean boInputMode = oC.getS( "QAE_mode" ).equalsIgnoreCase("I") || oC.getS( "QAE_mode" ).equalsIgnoreCase("T");
        boolean boEditMode = oC.getS( "QAE_mode" ).equalsIgnoreCase("T");

        // Other flash errors
        boolean boAlreadyFilledError = (oC.getI("QAE_FORM_ALREADY_FILLED_ERR") > 0);
        oC.putS("QAE_FORM_ALREADY_FILLED_ERR", "0");

        // Agent group icon and name
        String agentGroupIcon = FA.translateToAgentGroupIcon(oC.getLt("DATI_agentgroups"), oC.getI("QAE_agent_group_id"));
        agentGroupIcon = (agentGroupIcon.length() == 0) ? "" : "<IMG SRC=\"../img/agent_groups/" + agentGroupIcon + "\" ALT=\"\" TITLE=\"\" BORDER='0' > ";

        String agentGroupName = FA.translateToAgentGroupName(oC.getLt("DATI_agentgroups"), oC.getI("QAE_agent_group_id"));
        agentGroupName = (agentGroupName.length() == 0) ? "-" : agentGroupIcon + agentGroupName;


  // Dump del contesto
	// -----------------
	if ( K.SYS_DUMP_CONTESTO && false ) {
		out.println( "<!--  Dump del contesto " );
		out.println( oC.dump() );
		out.println( "-->\n\n" );
	}
%>

<html>
<head>

    <%= AssetManager.basicBundle(session, application, request) %>
    <title>QA Grading</title>

</head>

<body class="uk-padding-small">
  <script>
      // Below are the javascript funtions requiring decoder and/or context labels access
      var json_sources = <%@ include file="./popup_qa_grade_ajx_ds.jsp" %>;
      var json_sources_comments = <%@ include file="./popup_qa_addcomment_ajx_ds.jsp" %>;
      var hideNAQuestions = <%= (boInputMode)? 0 : 1 %>;
      var formInEditMode = <%= (boEditMode)? 1 : 0 %>;

      var alreadyFilled = <%= (boAlreadyFilledError)? 1 : 0 %>;

      var stWebHere = "<%=stWebHere %>";

      // js var with value from context
      var tagLine = "<%= oDec.k("qa_audio_recordings") %>";
      var record_tags_numtag = "<%= oDec.k("record_tags_numtag") %>";

      var oUhasKeyQA_REMOVE = <%=oU.hasKey("QA_REMOVE")%>;
      var oUhasKeyQA_REPLACE = <%=oU.hasKey("QA_REPLACE")%>;

      var oDeckqa_pop_form = "<%= oDec.k("qa_pop_form") %>";
      var oDeckqa_pop_comments = "<%= oDec.k("qa_pop_comments") %>";

      var oDeckqa_pop_delcommentsalert = "<%= oDec.k("qa_pop_delcommentsalert") %>";
      var KENCODING_UTF8 = "<%= K.ENCODING_UTF8 %>";

      var oDeckqa_frm_cmtdlg_title_about = "<%=oDec.k("qa_frm_cmtdlg_title_about")%>";
      var oDeckqa_frm_cmtdlg_title_ofform = "<%=oDec.k("qa_frm_cmtdlg_title_ofform")%>";

  </script>

<div id="timerdiv" class="uk-padding-small uk-margin-small-bottom"  uk-sticky>
  <div class="L-grid-3">
    <div class="L-text-center"><b>Timer</b></div>
    <div class="L-text-center" id="lblsec"></div>
    <div class="L-text-center">

      <span id="start" loway-icon="play"> </span>
      <span id="reset" loway-icon="refresh"> </span>
    </div>
  </div>
</div>

<div class="uk-child-width-1-5@s " uk-grid >

  <div class="uk-width-2-5@s">
    <!-- Average scores and totals -->
    <table class="qm-qa-average-scores-totals ST qm-table Q-table qm-table-striped L-width-100" >
      <tr class='ST_TRH'>
        <th><%= oDec.k("qa_level") %></th>
        <th align="center"><%= oDec.k("qa_range") %></th>
        <th align="right"><%= oDec.k("qa_items") %></th>
        <th align="center">&nbsp;</th>
      </tr>
      <tr class='ST_TR0' id="rt_row_rating_1">
        <td><div id="rt_rating_1">&nbsp;</div></td>
          <td align="center"><div id="rt_maxv_1">&nbsp;</div> </td>
          <td align="right"><div id="rt_count_1">&nbsp;</div> </td>
          <td align="center"><%= oH.checkBox("rt_check_1", ((boInputMode)? "display: none;" : "")) %></td>
      </tr>
      <tr class='ST_TR0' id="rt_row_rating_2"><td><div id="rt_rating_2">&nbsp;</div></td>
        <td align="center"><div id="rt_maxv_2">&nbsp;</div></td>
        <td align="right"><div id="rt_count_2">&nbsp;</div></td>
        <td align="center"><%= oH.checkBox("rt_check_2", ((boInputMode)? "display: none;" : "")) %></td>
      </tr>
      <tr class='ST_TR0' id="rt_row_rating_3"><td><div id="rt_rating_3">&nbsp;</div></td>
        <td align="center"><div id="rt_maxv_3">&nbsp;</div> </td>
        <td align="right"><div id="rt_count_3">&nbsp;</div> </td>
        <td align="center"><%= oH.checkBox("rt_check_3", ((boInputMode)? "display: none;" : "")) %></td>
      </tr>
      <tr class='ST_TR0' id="rt_row_rating_4"><td> <div id="rt_rating_4">&nbsp;</div> </td>
        <td align="center"><div id="rt_maxv_4">&nbsp;</div> </td>
        <td align="right"><div id="rt_count_4">&nbsp;</div> </td>
        <td align="center"><%= oH.checkBox("rt_check_4", ((boInputMode)? "display: none;" : "")) %></td>
      </tr>
    </table>
  </div>

  <div class="uk-width-2-5@s">
      <!-- Right header table -->
      <table class="ST qm-table Q-table qm-table-striped L-width-100" >
          <tr class='ST_TRH'><th colspan='2'> <%= oDec.k("qa_input_form") %> </th></tr>

          <tr class='ST_TR0'>
           <td><%= oDec.k("qa_form") %>:</td>
           <td><%= oH.combo( "QAE_formId", oC.getLt( "DATI_QAE_ltForms_tutti" ).numRows()>1, "", oC.getLt( "DATI_QAE_ltForms_tutti" ), 0, 1, "" ) %></td>
          </tr>

          <tr class='ST_TR0'>
              <td><%= oDec.k("qa_frm_st") %></td>
              <td><%= oH.combo( "QAE_frmStatus", false, "", "qa_form_status", "A" ) %></td>
          </tr>
      </table>

      <!-- End of right header table -->
    </div>

    <div class="popup_qa_grade buttons">
      <!-- Buttons -->

      <INPUT TYPE='button' ID="qaform_submit" CLASS='qm-qa-close qaButton Q-button' VALUE="<%= oDec.k("cld_pop_close") %>">

      <INPUT TYPE='button' ID="cmtbtn" CLASS='qm-qa-togglecomments qaButton Q-button'  VALUE="<%= oDec.k("qa_pop_comments")%>">
   </div>

      <div class="uk-width-2-5@s">
        <table class="ST qm-table Q-table qm-table-striped L-width-100" >
            <tr class='ST_TRH'><th colspan='4'><%= oDec.k("qa_overall_performance") %></th></tr>
            <%
              sectionTitleExtractor titleExtractor = new sectionTitleExtractor();
              titleExtractor.init(ltFormData);
              for (int i = 1; i <= QAFormInfo.MAX_SECTIONS; i++) {
                out.println("<tr class='ST_TR0' id='par_avg_row" + i + "'><td>" + titleExtractor.getSectionTitle(i-1) + "</td>");
                out.println("<td align='right'><span id='QAE_par_sum" + i + "' title='" + oDec.k("qa_score") + "'>0</span></td>");
                out.println("<td align='right'><span id='QAE_par_avg" + i + "' title='" + oDec.k("qa_avg_score") + "'>0</span></td>");
                out.println("<td>&nbsp;</td></tr>");
            } %>
            <% for (int i = 1; i <= QAFormInfo.MAX_SECTIONS; i++) {
                out.println("<tr class='ST_TR0' id='par_sum_row" + i + "' style='display: none;'><td>Par Sum " + i + ":</td><td colspan='2' align='right'><span id='QAE_par_sum" + i + "'>0</span></td><td>&nbsp;</td></tr>");
            }%>

            <tr class='ST_TR0'><td colspan='4'>&nbsp;</td></tr>
            <tr class='ST_TR0'><td><%= oDec.k("qa_total_score") %> </td><td colspan='2' align='right'><span id="tot_sum">0</span></td><td>&nbsp;</td></tr>
            <tr class='ST_TR0'><td><%= oDec.k("qa_average") %> </td><td colspan='2' align='right'><span id="tot_avg">0</span></td><td>&nbsp;</td></tr>

            <%
                // Task section
                LTable ltTaskList = oC.getLt("TASKS_FOR_CALL");
                if (ltTaskList.numRows() != 0) {
            %>
                <tr class='ST_TRH'><th colspan="4"><div><%= oDec.k("qa_input_form_tasks") %></div></th></tr>
                <tr class='ST_TR0'>
                    <td colspan="4" style='width:100%; padding:0;'>
                    <table style='width:100%; border:none; margin:0; border-collapse: collapse;'>
            <%
                    for (int row = 0; row < ltTaskList.numRows(); row++) {

                        int taskId = ltTaskList.getI(row, SearchTasksForQAPopup.COL_TASKID);
                        String taskIcon = ltTaskList.getS(row, SearchTasksForQAPopup.COL_TASKICONNAME);
                        String taskTitle = ltTaskList.getS(row, SearchTasksForQAPopup.COL_TASKTITLE);
                        if (taskId != 0) {
                            taskTitle = "<a href='qm_task_detail.do?TASK_tskid=" + taskId + "' target='_blank'>" + taskTitle + "</a>";
                        }
            %>
                        <tr>
                            <td><img src="../<%= taskIcon %>"/></td>
                            <td style='font-weight:normal;'><%= taskTitle %></td>
                        </tr>
            <%
                    }
            %>
                    </table>
                </td></tr>
            <%
                }
            %>
        </table>
        <!-- End of average scores and totals -->
      </div>

      <div class="uk-width-3-5@s">
        <table class="ST qm-table Q-table qm-table-striped L-width-100">
            <tr class='ST_TRH'><th colspan='2'> <%= oDec.k("qa_call_detail") %></th></tr>
            <tr class='ST_TR0'><td> <%= oDec.k("qa_start_time") %>:</td><td> <%= oC.getS("QAE_call_tst_hr") %></td></tr>
            <tr class='ST_TR0'><td> <%= oDec.k("qa_queue") %>:</td><td> <%= oC.getS("QAE_queue_hr") %></td></tr>
            <tr class='ST_TR0'><td> <%= oDec.k("qa_agent") %>:</td><td>  <%= oC.getS("QAE_agent_hr") %> </td></tr>
            <tr class='ST_TR0'><td> <%= oDec.k("qatarget_agentgroup") %>:</td><td>  <%= agentGroupName %> </td></tr>
            <tr class='ST_TR0'><td> <%= oDec.k("qa_caller") %>:</td><td> <%= oC.getS("QAE_caller") %> </td></tr>
            <tr class='ST_TR0'><td> <%= oDec.k("qa_astclid") %>:</td><td> <%= oC.getS("QAE_astclid") %> </td></tr>

            <%
                String statusCode = oC.getS("QAE_stcode");
                String statusCodeDesc = oC.getS("QAE_stcodeDesc");
                if (statusCode.length() != 0) {
                    statusCode = (statusCodeDesc.length() != 0)? statusCode + ": " + statusCodeDesc : statusCode;
                %>
                <tr class='ST_TR0'><td> <%= oDec.k("qa_frm_statuscode") %>:</td><td> <%= statusCode %> </td></tr>
            <% } %>

            <% if ( !boInputMode ) { %>
                <tr class='ST_TR0'><td> <%= oDec.k("qa_input_form") %>:</td><td> <%= oC.getS("QAE_formName") %></td></tr>
                <tr class='ST_TR0'><td> <%= oDec.k("qa_analyst") %>:</td><td> <%= oC.getS("QAE_trackedby") %></td></tr>
                <tr class='ST_TR0'><td> <%= oDec.k("qa_date") %>:</td><td> <%= oC.getS("QAE_trackdate") %></td></tr>
            <% }; %>

            <tr class='ST_TR0'><td colspan='2'> &nbsp; </td></tr>

            <tr class='ST_TRH'><th colspan='2'><div id="audio_recordings"></div></th></tr>
            <tr class='ST_TR0'><td colspan='2'>

            <%= PluggableListener.displayListOfFilesInPopup(oC,"qapopup") %>

            </td></tr>
            <%
                // Export job section
                LTable ltDatiExportJobs = oC.getLt( "DATI_export_jobs" );
                LTable ltFiles = oC.getLt("POPUP_FILES_ltList");

                if ((oU.hasKey("BATCH_ADD")) && (ltFiles.numRows() != 0) && (ltDatiExportJobs.numRows() != 0)) {
            %>
            <tr class='ST_TR0'>
                <td><%= oDec.k("qa_frm_addtojob") %></td>
                <td><%= oH.combo( "QAE_jobId", true, "", ltDatiExportJobs, 0, 1, "" ) %>
                    <INPUT TYPE='button' ID="addjobbtn"
                    CLASS='qaButton'
                    VALUE="<%= oDec.k("qa_frm_addbtn") %>"
                    onClick="addjob('<%= oC.getS("QAE_astclid") %>');"
                    STYLE="" >
                </td>
                <td></td>
            </tr>
            <%
                }
            %>
        </table>
      </div>
    <div>
  </div>
</div>

<center>

    <!-- Auxiliary information -->
    <p>
      <div id="formDeleted" style="color: red; display: none;"><%= oDec.k("qa_pop_deleted") %></div>
      <div id="formAlreadyFilled" style="color: red; display: none;"><%= oDec.k("qa_pop_alreadyfilled") %></div>
    </p>
    <!-- End of auxiliary information -->

<form id="qa_dtform" method="POST" action="<%= stWebHere %><%= K.TRANSACTION_CONTROLLER %>" encoding="<%= K.ENCODING_UTF8 %>">
    <INPUT TYPE="hidden" name="<%= K.REQ_VERBO %>" value="qm_qa_popup_commit">
    <INPUT TYPE="hidden" name="<%= K.REQ_PARAM %>" value="">

    <%= oH.hidden( "QAE_agent" ) %>
    <%= oH.hidden( "QAE_agent_group_id" ) %>
    <%= oH.hidden( "QAE_astclid" ) %>
    <%= oH.hidden( "QAE_call_tst" ) %>
    <%= oH.hidden( "QAE_caller" ) %>
    <%= oH.hidden( "QAE_queue" ) %>
    <%= oH.hidden( "QAE_stcode" ) %>
    <%= oH.hidden( "QAE_commentsEnabled" ) %>
    <%= oH.hidden( "QAE_mode" ) %>
    <%= oH.hidden( "QAE_qaDataID" ) %>
    <%= oH.hidden( "QAE_loadById" ) %>
    <%= oH.hidden( "QAE_tot_avg" ) %>

    <!-- Items div start here -->
    <div id="qaform" style="display: block;">
        <%
            SmartTable T = new SmartTable( "x", ltFormData );
            T.setDecoder( oDec );
            //T.addColumn( "Section",      0, "10px" );
            T.addColumn( oDec.k("qa_frm_code")   ,  1,  "70px", new qaCodeDecor() );
            T.addColumn( oDec.k("qa_frm_desc")   ,  2, "450px", new qaTitleDecor() );
            T.addColumn( oDec.k("qa_frm_status") ,  1, "120px", new qaStatusDecor() );
            T.addColumn( oDec.k("qa_frm_mandatory"), QAFormData.FIELDTYPE_MANDATORYVAL_COL, "70px", new qaMandatoryDecor(oH, boInputMode, 1, QAFormData.FIELD_MANDATORY_COL));
            T.addColumn( oDec.k("qa_frm_value")  ,  3, "110px", new QAItemTypeHandler( oDec, oH, boInputMode, boEditMode, 1, QAFormData.FIELDTYPE_COL, QAFormData.FIELDTYPE_MULTIOPTION_COL, QAFormData.FIELD_MANDATORY_COL, QAFormData.FIELDTYPE_MANDATORYVAL_COL ) );
            T.addColumn( oDec.k("qa_frm_about")  ,  1, "30px", new qaItemCommentsHandler(oDec));

            T.withTableClass( "qm-table Q-table Q-table-divider qm-table-striped L-width-100" );
            out.println(T.render());
        %>

        <p>

        <% if ( boInputMode ) { %>
            <% if (boEditMode) { %>
                <!-- Update button -->
                <INPUT TYPE='button'
                    CLASS='qaButton qm-qa-runupdate'
                    VALUE="<%= oDec.k("qa_btn_update") %>"
                    id="btnSave">
            <% } else { %>
                <!-- Save button -->
                <INPUT TYPE='button'
                    CLASS='qaButton qm-qa-runsave'
                    VALUE="<%= oDec.k("qa_btn_save") %>"
                    id="btnSave">
            <% } %>
        <% } else { %>

            <!-- Compact/Expanded mode -->
            <INPUT TYPE='button'
                   CLASS='qaButton qm-qa-runcompact'
                   VALUE="<%= oDec.k("qa_btn_compact") %>"
                   id="btnCompact">
                    &nbsp;
            <% if (oU.hasKey(("QA_REMOVE"))) { %>
                <!-- Delete button -->
                <INPUT TYPE='button'
                    CLASS='qaButton qm-qa-rundelete'
                    VALUE="<%= oDec.k("qa_btn_delete") %>"
                    ID="btnDelete">
            <% } %>
            <% if ( !boEditMode && oU.hasKey("QA_REMOVE") && oU.hasKey("QA_REPLACE") ) { %>
                <!-- Replace button -->
                <INPUT TYPE='button'
                    CLASS='qaButton qm-qa-runedit'
                    VALUE="<%= oDec.k("qa_btn_editscoredform") %>"
                    ID="btnUpdate" >
            <% } %>
        <% } %>
    </div>
    <!-- Items div ends here -->
</form>

<!-- This is the modal -->
<div id="commentDlg" loway-modal>
    <div>
        <h2 class="loway-modal-title"></h2>
        <div>
          <%= oH.textArea( "QAE_itemCommentTextArea",  true, "", 100000 ) %>
          <hidden id="QAE_commentItemId"/>
        </div>

        <div class="L-row L-gap-8 L-justify-flexend">
          <button class="Q-button Q-button-tertiary" id="LowayModal-cancel" type="button"><%= oDec.k("modal_cancel") %></button>
          <button class="Q-button Q-button-primary qm-button-ok" id="LowayModal-ok" autofocus="" ><%= oDec.k("modal_ok") %></button>
        </div>

        <hr>
<%-- this table is styled with the selector #QAE_itemCommentHistoricalArea table  --%>
        <div id="QAE_itemCommentHistoricalArea">
            <!-- Here will be the already inserted comments for a question item -->
        </div>
    </div>
</div>


<!-- notes and record tags -->
<div id="comments" style="display: none;">
  <div class="qapopup-wrapper">
    <div class="comment"><%= oH.textArea( "QAE_comment",  true, "width:600px; height: 90px;", 100000 ) %></div>
    <div class="button"><INPUT TYPE='button' CLASS='Q-button Q-button-primary qm-qa-insertnewcomment qaButton ' VALUE="<%= oDec.k("qa_pop_addcomment") %>"></div>
  </div>

  <div id="oldcomments">
      <!-- Here will be already inserted comments -->
  </div>

  <% if (oU.hasKey("QA_REMOVE")) { %>
      <div id="divBtnRemove">
          <INPUT TYPE='button' CLASS='Q-button Q-button-primary qaButton ' VALUE="<%= oDec.k("qa_pop_delcomments") %>" >
      </div>
  <% } %>

  <br>&nbsp;<hr>

  <!-- Recording tags list and buttons -->
  <%@ include file="../qm/qm_recordtag_list.jsp" %>
  <!-- End of recording tags list and buttons -->
</div>
<!-- end of notes and record tags -->


      </center>

    <img alt="spacer" src="../img/spacer.gif" width="1" height="1" id="keepalive">

  </body>
</html>