<%@ page language="java" %>
<%@ page import="it.loway.tpf.*" %>
<%@ page import="it.loway.tpf.common.containers.*" %>
<%@ page import="it.loway.tpf.common.interfaces.*" %>
<%@ page import="it.loway.tpf.common.exceptions.*" %>
<%@ page import="it.loway.tpf.presentation.html.*" %>
<%@ page import="it.loway.tpf.presentation.html.decorators.*" %>
<%@ page import="it.loway.app.queuemetrics.smartTableDecorators.*" %>
<%@ page import="it.loway.app.queuemetrics.smartTableDecorators.QA.*" %>
<%@ page import="it.loway.app.queuemetrics.caricamento.DataObjects.*" %>
<%@ page import="it.loway.app.queuemetrics.caricamento.QA.*" %>
<%@ page import="java.util.*" %>
<%
    // se non ho un contesto,
    // forza una transazione per iniziare....
    FA.startTransactionIfNoUser( request, response, "qm_start", "" );
%>
<%
    // BUNDLES SPECIFICI PER LA PAGINA. VENGONO IMPORTATI IN PAGINA DA 00_page_header.jsp
        String pageBundle = AssetManager.basicBundle(session, application, request);

%>
<%@ include file="/includes/00_page_header.jspf" %>
<script defer>
function onLoadApplicativo() {
	// transazione standard
	document.forms[0].<%= K.REQ_VERBO %>.value = "";
	document.forms[0].<%= K.REQ_PARAM %>.value = "";
}
</script>

<div class="qm-form-body L-column L-gap-24">
  <h1><%= oDec.k("clhdr_report_details") %></h1>  
  <%
    LTable ltFilterBy = oC.getLt("QAR_FilterBySpec");
    if (ltFilterBy.numRows() != 0) {

        SmartTable T = new SmartTable( "x", ltFilterBy );
        T.setDecoder(oDec);
        //T.withCaption( );
        T.withTableClass( "qm-table Q-table L-width-50 L-padding-8 L-border L-border-radius-2" );
        T.addSortableColumn( "" ,  0, "100",  SmartTable.SORT_NONE );
        T.addSortableColumn( "" , 1, "200",  SmartTable.SORT_NONE );
        out.println(T.render());
    }
  %>

  <h1><%= oDec.k("qa_reports_mcr_title") %></h1>

  <%
    class infoAndUsersMergerDecor implements TpfCellDecoratorInterface {

      int infoColumn = 0;
      int usersColumn = 0;
      LTable ltUsers = new LTable();

      public infoAndUsersMergerDecor (int infoColumn, int usersColumn, LTable ltUsers) {

          this.infoColumn = infoColumn;
          this.usersColumn = usersColumn;
          this.ltUsers = ltUsers;
      }

      public String decorate(LTable lt, int r, int c, String width) throws TechException {

          String infoString = lt.getS(r, infoColumn);

          if (infoString.length() != 0)
              return "<td class='stData' style='width: " + width + ";'> " + infoString + "</td>\n";

          String stUserId = lt.getS(r, usersColumn);
          String stUserLogin = FA.decodificaDaLTable(stUserId, ltUsers, 0, 1, true);
          String stUserName = FA.decodificaDaLTable(stUserId, ltUsers, 0, 2, false);

          if (stUserName.length() != 0)
              return  "  <td class='stData' style='width: " + width + "; color: gray;'>&nbsp;&nbsp;&nbsp;" + stUserName + " </td>\n";

          return  "  <td class='stData' style='width: " + width + "; color: gray;'>&nbsp;&nbsp;&nbsp;" + stUserLogin + "</td>\n";
      }
    }
  %>

  <div class="L-column L-gap-48">
    <!----- FORM REPORT ----->
    <div class="L-column L-gap-16">
      <h3 class="L-heading-divider"><%= oDec.k("qa_reports_mcr_formreport") %></h3>

      <%
        LTable ltCalibrationFormReport = oC.getLt("QAR_CalibrationFormReport");
        if (ltCalibrationFormReport.numRows() != 0) {

          SmartTable T = new SmartTable( "x", ltCalibrationFormReport );
          T.setDecoder(oDec);
          //T.withCaption( );
          T.withTableClass( "qm-table Q-table qm-table-striped L-width-100" );
          T.addSortableColumn( oDec.k("qa_reports_mcr_form_name"), 1, "200",  new infoAndUsersMergerDecor(0, 1, oC.getLt("DATI_users")), SmartTable.SORT_NONE);
          T.addSortableColumn( oDec.k("qa_reports_mcr_calls"), 2, "80",  SmartTable.SORT_NONE );
          T.addSortableColumn( oDec.k("qa_reports_mcr_average"), 3, "80",  SmartTable.SORT_NONE );
          T.addSortableColumn( oDec.k("qa_reports_mcr_delta"), 4, "40",  new percentDecor(100.0f).blankEmptyLines(true), SmartTable.SORT_NONE );
          T.withTableClass( "qm-table Q-table qm-table-striped L-width-100" );
          out.println(T.render());
        }
      %>
    </div>

    <!----- FORM SECTIONS REPORT ----->
    <div class="L-column L-gap-16">
      <h3 class="L-heading-divider"><%= oDec.k("qa_reports_mcr_sectionsreport") %></h3>
      <%
        LTable ltCalibrationSectionReport = oC.getLt("QAR_CalibrationSectionReport");
        if (ltCalibrationSectionReport.numRows() != 0) {

          SmartTable T = new SmartTable( "x", ltCalibrationSectionReport );
          T.setDecoder(oDec);
          //T.withCaption( );
          T.withTableClass( "qm-table Q-table qm-table-striped L-width-100" );
          T.addSortableColumn( oDec.k("qa_reports_mcr_sectionname"), 1, "200",  new infoAndUsersMergerDecor(0, 1, oC.getLt("DATI_users")), SmartTable.SORT_NONE);
          T.addSortableColumn( oDec.k("qa_reports_mcr_nitems"), 3, "50",  SmartTable.SORT_NONE );
          T.addSortableColumn( oDec.k("qa_reports_mcr_average"), 2, "80",  SmartTable.SORT_NONE );
          T.addSortableColumn( oDec.k("qa_reports_mcr_delta"), 4, "40",  new percentDecor(100.0f).blankEmptyLines(true), SmartTable.SORT_NONE );
          T.withTableClass( "qm-table Q-table qm-table-striped L-width-100" );
          out.println(T.render());
        }
      %>
    </div>

    <!----- FORM ITEMS REPORT ----->
    <div class="L-column L-gap-16">
      <h3 class="L-heading-divider"><%= oDec.k("qa_reports_mcr_itemsreport") %></h3>
      <%
        LTable ltCalibrationItemsReport = oC.getLt("QAR_CalibrationItemsReport");
        if (ltCalibrationItemsReport.numRows() != 0) {

          SmartTable T = new SmartTable( "x", ltCalibrationItemsReport );
          T.setDecoder(oDec);
          //T.withCaption( );
          T.withTableClass( "qm-table Q-table qm-table-striped L-width-100" );
          T.addSortableColumn( oDec.k("qa_reports_mcr_code"),  0, "50",  SmartTable.SORT_NONE );
          T.addSortableColumn( oDec.k("qa_reports_mcr_question"), 1, "300",  new infoAndUsersMergerDecor(1, 2, oC.getLt("DATI_users")), SmartTable.SORT_NONE);
          T.addSortableColumn( oDec.k("qa_reports_mcr_nitems"), 4, "50",  SmartTable.SORT_NONE );
          T.addSortableColumn( oDec.k("qa_reports_mcr_average"), 3, "80",  new QANumberWithNA().markInGray(6), SmartTable.SORT_NONE );
          T.addSortableColumn( oDec.k("qa_reports_mcr_delta"), 5, "40",  new percentDecor(100.0f).blankEmptyLines(true).markInGray(6), SmartTable.SORT_NONE );
          T.withTableClass( "qm-table Q-table qm-table-striped L-width-100" );
          out.println(T.render());
        }
      %>
    </div>
  </div>
</div>

<%@ include file="/includes/00_page_footer.jspf" %>