<%@ page language="java" %>
<%@ page import="it.loway.tpf.*" %>
<%@ page import="it.loway.tpf.common.containers.*" %>
<%@ page import="it.loway.tpf.common.debug.*" %>
<%@ page import="it.loway.tpf.common.interfaces.*" %>
<%@ page import="it.loway.tpf.common.exceptions.*" %>
<%@ page import="it.loway.tpf.presentation.html.*" %>
<%@ page import="it.loway.tpf.presentation.html.decorators.*" %>
<%@ page import="it.loway.app.queuemetrics.*" %>

<%
  String stButtonsWidth = "";
  // moveActionsEnabled = true;
%>

<!-- Tab Navigation -->
<ul id="tabs-menu" class="loway-tabs" role="tablist">
  <% int tabIndex = 1; %>
  <% boolean isFirstTab = true; %>
  
  <% if (moveActionsEnabled) { %>
    <!-- Tab 1 -->
    <li class="loway-tab-item active" role="tab" aria-selected="true" data-tab-target="#tab<%= tabIndex %>">
      <a href="#"><%= oDec.k("qa_perftrack_movetogroup") %></a>
    </li>
    <% tabIndex++; %>
    <% isFirstTab = false; %>
  <% } %>

  <!-- Tab 2 -->
  <li class="loway-tab-item <%= isFirstTab ? "active" : "" %>" role="tab" aria-selected="<%= isFirstTab ? "true" : "false" %>" data-tab-target="#tab<%= tabIndex %>">
    <a href="#"><%= oDec.k("qa_perftrack_sendcbt") %></a>
  </li>
  <% tabIndex++; %>
  <% isFirstTab = false; %>

  <!-- Tab 3 -->
  <li class="loway-tab-item" role="tab" aria-selected="false" data-tab-target="#tab<%= tabIndex %>">
    <a href="#"><%= oDec.k("qa_perftrack_sendmeeting") %></a>
  </li>
</ul>


<!-- Tab Content -->
<div class="loway-tab-content">
  <% tabIndex = 1; %>

  <% if (moveActionsEnabled) { %>
    <!-- Tab 1 Content -->
    <div id="tab<%= tabIndex %>" class="loway-tab-panel active" role="tabpanel">
      <div class="L-padding-24">
        <!-- Content for Tab 1 -->
        <div class="L-column L-gap-24">
          <h3><%= oDec.k("qa_perftrack_movetogroup") %></h3>
          <div class="L-column L-gap-16">
            <!-- Form Fields -->
            <div class="L-column L-gap-8">
              <label for="QA_TASK_newAgentGroup"><%= oDec.k("qa_perftrack_new_group") %></label>
              <div><%= oH.combo("QA_TASK_newAgentGroup", true, stControlsWidth, oC.getLt("DATI_agentgroups_selectable"), 0, 1, "") %></div>
            </div>

            <div class="L-row L-gap-8">
              <%= oH.checkBox("QA_TASK_Remember", "") %>
              <label for="QA_TASK_RememberPeriod"><%= oDec.k("qa_perftrack_remember") %> &nbsp;</label>
              <%= oH.textBox("QA_TASK_RememberPeriod", true, stNumbersWidth, 10) %>&nbsp;
              <%= oDec.k("qa_perftrack_days") %>
            </div>

            <div class="L-column L-gap-8">
              <label><%= oDec.k("qa_perftrack_reason") %></label>
              <div><%= oH.textBox("QA_TASK_reason_MoveGroup", true, stControlsWidth, 1024) %></div>
            </div>
          </div>
          <div class="L-justify-flexend">
            <input class="Q-button-primary" id="okButtonMove" type="button" onclick="onMoveToGroup()" value="OK" />
          </div>
        </div>
      </div>
    </div>
    <% tabIndex++; %>
  <% } %>

  <!-- Tab 2 Content -->
  <div id="tab<%= tabIndex %>" class="loway-tab-panel <%= !moveActionsEnabled ? "active" : "" %>" role="tabpanel">
    <div class="L-padding-24">
      <!-- Content for Tab 2 -->
      <div class="L-column L-gap-24">
        <h3><%= oDec.k("qa_perftrack_sendcbt") %></h3>
        <div class="L-column L-gap-16">
          <!-- Form Fields -->
          <div class="L-column L-gap-8">
            <label for="QA_TASK_CBTName"><%= oDec.k("qa_perftrack_cbt_id") %></label>
            <div><%= oH.comboX("QA_TASK_CBTName", true, stControlsWidth, oC.getLt("DATI_CBTList_selectable"), 1, 2, "") %></div>
          </div>

          <div class="L-column L-gap-8">
            <label for="QA_TASK_CBTText"><%= oDec.k("qa_perftrack_cbt") %></label>
            <div><%= oH.textBox("QA_TASK_CBTText", true, stControlsWidth, 1024) %></div>
          </div>

          <div class="L-column L-gap-8">
            <label for="QA_TASK_CBTNote_CBT"><%= oDec.k("qa_perftrack_cbt_comment") %></label>
            <div><%= oH.textBox("QA_TASK_CBTNote_CBT", true, stControlsWidth, 1024) %></div>
          </div>

          <div class="L-column L-gap-8">
            <label><%= oDec.k("qa_perftrack_reason") %></label>
            <div><%= oH.textBox("QA_TASK_reason_CBT", true, stControlsWidth, 1024) %></div>
          </div>

          <div class="L-justify-flexend">
            <input class="Q-button-primary" id="okButtonSendCBT" type="button" onclick="onSendCBT()" value="OK" />
          </div>
        </div>
      </div>
    </div>
    <% tabIndex++; %>

  <!-- Tab 3 Content -->
  <div id="tab<%= tabIndex %>" class="loway-tab-panel" role="tabpanel">
    <div class="L-padding-24">
      <!-- Content for Tab 3 -->
      <div class="L-column L-gap-24">
        <h3><%= oDec.k("qa_perftrack_sendmeeting") %></h3>
        <div class="L-column L-gap-16">
          <!-- Form Fields -->
          <div class="L-column L-gap-8">
            <label for="QA_TASK_CHCTitle"><%= oDec.k("tsk_traincoach_chc_title") %></label>
            <div><%= oH.textBox("QA_TASK_CHCTitle", true, stControlsWidth, 1024) %></div>
          </div>

          <div class="L-column L-gap-8">
            <label for="QA_TASK_CHCMessage"><%= oDec.k("tsk_traincoach_chc_message") %></label>
            <div><%= oH.textBox("QA_TASK_CHCMessage", true, stControlsWidth, 1024) %></div>
          </div>

          <div class="L-column L-gap-8">
            <label for="QA_TASK_CHCDate_date"><%= oDec.k("tsk_traincoach_chc_date") %></label>
            <div class="qm-form-datehourpicker"><%= FA.generaJQueryComboDataOra("QA_TASK_CHCDate", oC, oH, true, oDec) %></div>
          </div>

          <div class="L-column L-gap-8">
            <label for="QA_TASK_CHCDuration"><%= oDec.k("tsk_traincoach_chc_duration") %></label>
            <div><%= oH.textBox("QA_TASK_CHCDuration", true, stControlsWidth, 1024) %></div>
          </div>

          <div class="L-column L-gap-8">
            <label><%= oDec.k("qa_perftrack_cbt_comment") %></label>
            <div><%= oH.textBox("QA_TASK_CBTNote_Meeting", true, stControlsWidth, 1024) %></div>
          </div>

          <div class="L-column L-gap-8">
            <label><%= oDec.k("qa_perftrack_reason") %></label>
            <div><%= oH.textBox("QA_TASK_reason_Meeting", true, stControlsWidth, 1024) %></div>
          </div>

          <div class="L-justify-flexend">
            <input class="Q-button-primary" id="okButtonSendMeeting" type="button" style="<%= stButtonsWidth %>" onclick="onSendMeeting()" value="OK" />
          </div>
        </div>
      </div>
    </div>
  </div>
</div>


<!-- Fields in tabs are placeholder. POSTed values are below -->
<%= oH.hidden( "QA_TASK_reason" ) %>
<%= oH.hidden( "QA_TASK_CBTNote" ) %>
<%= oH.hidden( "QA_TASK_CBTCallId" ) %>
<%= oH.hidden( "QA_TASK_CBTAgentCode" ) %>

<script>
  var qa_perftrack_sendcbtforcall = "<%= oDec.k("qa_perftrack_sendcbtforcall") %>";
  var qa_perftrack_sendmeetingforcall = "<%= oDec.k("qa_perftrack_sendmeetingforcall") %>";
  var qa_perftrack_sendcbt = "<%= oDec.k("qa_perftrack_sendcbt") %>";
  var qa_perftrack_sendmeeting = "<%= oDec.k("qa_perftrack_sendmeeting") %>";
</script>
