<%@ page language="java" %>
<%@ page import="it.loway.tpf.*" %>
<%@ page import="it.loway.tpf.common.containers.*" %>
<%@ page import="it.loway.tpf.common.interfaces.*" %>
<%@ page import="it.loway.tpf.common.exceptions.*" %>
<%@ page import="it.loway.tpf.presentation.html.*" %>
<%@ page import="it.loway.tpf.presentation.html.decorators.*" %>
<%@ page import="it.loway.app.queuemetrics.caricamento.DataObjects.*" %>
<%@ page import="it.loway.app.queuemetrics.caricamento.QA.*" %>
<%@ page import="it.loway.app.queuemetrics.DO.SearchQuery"%>
<%@ page import="java.util.*" %>
<%
  // se non ho un contesto,
  // forza una transazione per iniziare....
  FA.startTransactionIfNoUser( request, response, "qm_start", "" );

%>
<%
    // BUNDLES SPECIFICI PER LA PAGINA. VENGONO IMPORTATI IN PAGINA DA 00_page_header.jsp
        String pageBundle = AssetManager.basicBundle(session, application, request);

%>
<%@ include file="/includes/00_page_header.jspf" %>
<div class="qm-form-body L-column L-gap-24">
<%
    // inizializza Decodes
    //oDec.load( "ricerchePubbliche", "ricerchePubbliche.txt", 0, 1 );
    //oDec.load( "statusCalls", "status_calls.txt", 0, 1);

    String stWidth = "";

    // Instanzia Data  Object appropriato
    QualityAssessmentDO doQA = new QualityAssessmentDO();
    LProperties props = FA.props( application );
    doQA.initJsp( oC, oDec, oU, props, stWebHere );

    SmartTable T = null;

    // This is the QA Data Object
    QAPopupDO qaDO = new QAPopupDO();
    qaDO.initForRatingsDisplay(oC, oDec, oU);
%>

  <script defer="defer">

    var json_sources = {
      "rt_rating": <%= qaDO.renderLimitsNames() %>,
      "rt_rating_colors": <%= qaDO.renderLimitsColors() %>,
      "rt_maxv": <%= qaDO.renderLimitsRanges() %>,
      "rt_boundaries": <%= qaDO.renderRatingsBoundaries() %>,
      "rt_visibility": <%= qaDO.renderRatingsGroupsVisibilityStatus() %>,
      "rt_colors": ['red', 'darkorange', 'blue', 'green']
    }

    function onLoadApplicativo() {
      // transazione standard
      document.forms[0].<%= K.REQ_VERBO %>.value = "";
      document.forms[0].<%= K.REQ_PARAM %>.value = "";

      initEventHandlers();
      updateRatings();
      hilite();
    }

    function initEventHandlers() {

      $("input[id^=checkbox_rt_check]").bind("click", function hideShowItemsByLevel() {

        var name = this.id;
        var value = this.checked;
        var sectionNum = name.substring(name.length - 1, name.length) - 1;

        json_sources["rt_visibility"][sectionNum] = value;

        hilite();
      });
    }

    function updateRatings() {

      // Update the ratings cells
      $.map($(".ST_TR0 > td > div[id^=rt_]"), function (value) {
        var name = value.id;
        var subName = name.substring(0, name.length - 2);
        var sectionNum = name.substring(name.length - 1, name.length) - 1;
        if (subName == "rt_rating") {
          var label = json_sources[subName][sectionNum];
          if (label.length == 0) {
            label = "- - - -";
          }
          value.innerHTML = "<font color='" + json_sources[subName + "_colors"][sectionNum] + "'>" + label + "</font>";
        } else {
          value.innerHTML = json_sources[subName][sectionNum];
        }
      });

      // Update the ratings checkboxes
      $.map($("input[id^=checkbox_rt_check]"), function (value) {
        var name = value.id;
        var sectionNum = name.substring(name.length - 1, name.length) - 1;
        value.checked = json_sources["rt_visibility"][sectionNum];
      });
    }

    function hilite() {

      var items = $("td[qmvalue]");
      $.map(items, function (value) {

        var qmVal = $(value).attr('qmvalue');

        for (var i = 0; i < json_sources['rt_colors'].length; i++) {

          var minVal = json_sources['rt_boundaries'][i][0] * 100;
          var maxVal = (json_sources['rt_boundaries'][i][1] * 100) + 99;
          var color = json_sources['rt_colors'][i];
          var visibility = json_sources['rt_visibility'][i];

          if ((qmVal >= minVal) && (qmVal <= maxVal)) {
            if (visibility) {
              $(value).css('color', color);
            } else {
              $(value).css('color', 'gray');
            }
          }
        }
      });
    }
  </script>

<h1>Report Details</h1>

<div class="L-row L-justify-spacebetween L-align-flexstart">
  <div class="L-column L-flex-2">
    <div class="L-table">
    <%
      LTable ltFilterBy = oC.getLt("QAR_FilterBySpec");
      if (ltFilterBy.numRows() != 0) {

          T = new SmartTable( "x", ltFilterBy );
          T.setDecoder(oDec);

          //T.withCaption( oDec.k("qa_gradings_stats") );
          T.withTableClass( "qm-table Q-table" );

          T.addSortableColumn( "Report Details:" ,  0, "100",  SmartTable.SORT_NONE );
          T.addSortableColumn( "&nbsp" , 1, "200",  SmartTable.SORT_NONE );
          out.println(T.render());
      }
    %>
    </div>
  </div>
  
  <div>
    <div class="L-column">
      <div class="L-grid-3">
  
        <label for=""></label>
        <div></div>
  
        <label for=""></label>
        <div></div>
  
        <label for=""></label>
        <div></div>
  
      </div>
  
    </div>
  </div>
  
  
</div>

  <h3><%= oDec.k("qa_reports") %>: <%= oDec.k("qa_summary_data") %></h3>
  <%
    T = doQA.dispatch( QualityAssessmentDO.FORM_OVERALL_SUMMARY, "" );
    T.withCaption(oDec.k("qa_reports_summary_overall") );
    T.withTableClass( "qm-table Q-table qm-table-striped" );
    out.println(T.render());
  %>
  <%= doQA.exportButtons( oDec, QualityAssessmentDO.THIS_DO, QualityAssessmentDO.FORM_OVERALL_SUMMARY ) %>

  <%
    T = doQA.dispatch( QualityAssessmentDO.SCORING_ITEMSFORM_SUMMARY, "" );
    T.withCaption(oDec.k("qa_reports_summary_scoring"));
    T.withTableClass( "qm-table Q-table qm-table-striped" );
    out.println(T.render());
  %>
  <%= doQA.exportButtons( oDec, QualityAssessmentDO.THIS_DO, QualityAssessmentDO.SCORING_ITEMSFORM_SUMMARY ) %>
  <br><small>(*)<%= oDec.k("qa_reports_note") %></small>
  <%
  T = doQA.dispatch( QualityAssessmentDO.NONSCORING_ITEMSFORM_SUMMARY, "" );
  T.withCaption(oDec.k("qa_reports_summary_nonscoring"));
  T.withTableClass( "qm-table Q-table qm-table-striped" );
  out.println(T.render());
  %>
  <%= doQA.exportButtons( oDec, QualityAssessmentDO.THIS_DO, QualityAssessmentDO.NONSCORING_ITEMSFORM_SUMMARY ) %>
  <br><small>(*)<%= oDec.k("qa_reports_note") %></small>
</div>

<%@ include file="/includes/00_page_footer.jspf" %>