<%@ page language="java" %>
<%@ page import="it.loway.tpf.*" %>
<%@ page import="it.loway.tpf.common.containers.*" %>
<%@ page import="it.loway.tpf.common.interfaces.*" %>
<%@ page import="it.loway.tpf.common.exceptions.*" %>
<%@ page import="it.loway.tpf.presentation.html.*" %>
<%@ page import="it.loway.tpf.presentation.html.decorators.*" %>
<%@ page import="java.util.*" %>
<%
    // se non ho un contesto,
    // forza una transazione per iniziare....
    FA.startTransactionIfNoUser( request, response, "qm_start", "" );
%>
<%
    // BUNDLES SPECIFICI PER LA PAGINA. VENGONO IMPORTATI IN PAGINA DA 00_page_header.jsp
        String pageBundle = AssetManager.basicBundle(session, application, request);

%>
<%@ include file="/includes/00_page_header.jspf" %>
<style>

    .outcomestable {
            border: none;
    }

    .outcomestable  td {
            border: none !important;
    }

    .outcomestable tr:first-of-type {
            font-weight: normal !important;
    }
</style>
<%
    // inizializza Decodes
    oDec.load( "masterkeyAbilitato", "masterkey_abilitato.txt", 0, 1 );
    final String stVerbPrefix = "qm_cfg2_features";
    final String stTabPrefix  = "TABCALL_FEATURES";
    String stWidth = "";
%>

<script>
var outcomeslist = <%= oC.getS("FEATURES_JSON_STATUS_CODELIST") %>;

function onLoadApplicativo() {

	// transazione standard
	document.forms[0].<%= K.REQ_VERBO %>.value = "";
	document.forms[0].<%= K.REQ_PARAM %>.value = "";

	populateDropdownOutcome();
	updateOutcomeTable();

        setFocus( "TABCALL_FEATURES_feat_code" );
}

function getOutcomeLabel(index) {

	var value = outcomeslist[index];

	var code = "[" + value[0] + "] ";
	var label = value[1];
	var isContact = (value[2] != "0")? " (C)" : "";
	var isSale = (value[3] != "0")? " (S)" : "";
	var isQContact = (value[4] != "0")? " (Q)" : "";

	var llb = code + label + isContact + isSale + isQContact;

	return llb;
}

function getOutcomeLabelsHash() {

	var result = [];
	$.each(outcomeslist,
		function(index, value) {

			var llb = getOutcomeLabel(index);
			var code = value[0];

			result[code] = llb;
		}
	);

	return result;
}

function populateDropdownOutcome() {

	// Loop on each outcome list, if any
	$.each(outcomeslist,
		function(index,value) {

			var llb = getOutcomeLabel(index);
			$('<option value="' + index + '">'+ llb + '</option>').appendTo("#ddOutcomes");
		}
	);

	// Enable the "add" button if at least one outcome is present
	if (outcomeslist.length != 0) {
		$("#addOutcome").removeAttr("disabled");
		$("#delOutcome").removeAttr("disabled");
	}
}

function getSelectedOutcomes() {

	var str = $("#TABCALL_FEATURES_relev_outcomes").val();
	str = $.trim(str);
	items = str.split("|");
	if (str.length == 0) {
		items = [];
	}

	return items;
}

function onAddOutcome() {

	var index = $("#ddOutcomes").val();
	var code = outcomeslist[index][0];

	var items = getSelectedOutcomes();

	if ($.inArray(code, items) == -1) {
		items.push(code);
		str = items.join("|");
		$("#TABCALL_FEATURES_relev_outcomes").val(str);
		updateOutcomeTable();
	}
}

function onDelOutcome() {

	var index = $("#ddOutcomes").val();
	var code = outcomeslist[index][0];

	var items = getSelectedOutcomes();

	if ($.inArray(code, items) != -1) {
		items = jQuery.grep(items, function(value) {
		  return value != code;
		});
		str = items.join("|");
		$("#TABCALL_FEATURES_relev_outcomes").val(str);
		updateOutcomeTable();
	}
}

function updateOutcomeTable() {

	var items = getSelectedOutcomes();
	var labels = getOutcomeLabelsHash();

	var table = "<table class='outcomestable'>";
	$.each(items,
		function (index, val) {
			var label = labels[val];
			table = table + "<tr><td>" + label + "</tr></td>";
		}
	);
	table = table + "</table>";

	$("#outcomeTable").html(table);
}

</script>

<div class="qm-form-body L-column L-gap-48">
  <div class="L-row L-justify-spacebetween">
	<h2><%= oDec.k("edit_record_features_title") %></h2>
    <!------------ Not editable items ---------------->
    <%= LowayHtml.sysFields( oC, oDec, "TABCALL_FEATURES", "feat_id" ) %>
  </div>
  
  <div class="L-column L-gap-24">
    <div class="L-row L-gap-16">
      <div class="L-column L-gap-8 L-width-25">
        <label for="TABCALL_FEATURES_feat_code"><%= oDec.k("edit_record_features_code") %></label>
        <div><%= oH.textBox( "TABCALL_FEATURES_feat_code",  true, stWidth, 45 ) %></div>
      </div>

      <div class="L-column L-gap-8 L-width-50">
        <label for=""><%= oDec.k("edit_record_description") %></label>
        <div><%= oH.textBox( "TABCALL_FEATURES_feat_descr",  true, stWidth, 100 ) %></div>
      </div>
    </div>

    <div class="L-row L-gap-16 L-align-flexstart">
      <div class="L-column L-gap-8 L-width-25">
        <label for="TABCALL_FEATURES_isGoal"><%= oDec.k("edit_record_features_goal") %></label>
        <div><%= oH.combo( "TABCALL_FEATURES_isGoal", true, stWidth, oC.getLt( "TABCALL_FEATURES_goalyesno" ), 0, 1, "0" ) %></div>
      </div>

      <div class="L-column L-gap-8">
        <label for="TABCALL_FEATURES_read_key"><%= oDec.k("edit_record_securitykey") %></label>
        <div><%= oH.textBox( "TABCALL_FEATURES_read_key",  true, stWidth, 100 ) %></div>
      </div>
    </div>
  </div>

	<div class="L-row L-gap-16 L-align-flexstart">
    <div class="L-column L-gap-8 L-width-25">
      <label for="TABCALL_FEATURES_seckey_queues"><%= oDec.k("edit_record_features_visibility") %></label>
      <div><%= oH.textArea( "TABCALL_FEATURES_seckey_queues",  true, stWidth + "height: 90px;", 10000 ) %></div>
    </div>

    <div class="L-column L-gap-8 L-width-25">
      <label for="ddOutcomes"><%= oDec.k("edit_record_features_outcomes") %></label>
      <div class="L-row L-gap-16">
        <select id="ddOutcomes" name="ddOutcomes" CLASS='Input' STYLE="width: 100%;"></select>
        <div class="L-row L-gap-16">
          <button id="addOutcome" class='Q-button-primary' onclick="onAddOutcome(); return false;" disabled >Add</button>
          <button id="delOutcome" class='Q-button-secondary' onclick="onDelOutcome(); return false;" disabled >Delete</button>
        </div>
      </div>
      
      <div id="outcomeTable"> 
        <%= oH.hidden( "TABCALL_FEATURES_relev_outcomes") %>
      </div>
    </div>
	</div>

  <div class="L-row L-justify-spacebetween">
    <%= oH.iconButton( "<span loway-icon='chevron-left'></span>"+oDec.k("edit_record_back"), true, "", stVerbPrefix + "_list", "", "Q-button-tertiary") %>
    <div class="L-row L-gap-16">
      <%= oH.button( oDec.k("edit_record_new"), (oC.getI("TABCALL_FEATURES_feat_id") > 0 ), "", stVerbPrefix + "_edit", "N", "Q-button-secondary") %>
      <%= oH.button( oDec.k("edit_record_clone"), (oC.getI("TABCALL_FEATURES_feat_id") > 0 ), "", stVerbPrefix + "_edit", "C", "Q-button-secondary") %>
      <%= oH.buttonScript( oDec.k("edit_record_delete"), (oC.getI("TABCALL_FEATURES_feat_id") > 0 ), "", "deleteSingleRecord('"+stVerbPrefix+"','"+oC.getS("TABCALL_FEATURES_feat_code")+"','"+oC.getS("TABCALL_FEATURES_feat_id")+"')", "Q-button-secondary") %>
    </div>
    <%= oH.button( oDec.k("edit_record_save"), true, "", stVerbPrefix + "_edit", "S" ) %>
  </div>
</div>

<%@ include file="/includes/00_page_footer.jspf" %>
