<%@ page language="java" %>
<%@ page import="it.loway.tpf.*" %>
<%@ page import="it.loway.tpf.common.containers.*" %>
<%@ page import="it.loway.tpf.common.interfaces.*" %>
<%@ page import="it.loway.tpf.common.exceptions.*" %>
<%@ page import="it.loway.tpf.presentation.html.*" %>
<%@ page import="it.loway.tpf.presentation.html.decorators.*" %>
<%@ page import="it.loway.app.queuemetrics.configurazione.QAFormInfo" %>
<%@ page import="java.util.*" %>
<%
    // Render the list of items composing a section
    class ItemsListRenderer {
        public ItemsListRenderer() {};
        public String RenderList(LTable ltItems) {
            String sResult = "<div style=\"font-size: 0.75em;\">";
            if (ltItems.numRows() > 0) {
                sResult += "(";
                for (int i = 0; i < ltItems.numRows(); i++) {
                    sResult += ltItems.getS(i, 0);
                    if (i != ltItems.numRows() - 1)
                        sResult += ", ";
                    if ((i+1)%14 == 0)
                        sResult += "<br>";
                }
                sResult += ")";
            } else {
                sResult += "No items";
            }
            sResult += "</div>";
            return sResult;
        }
    }
%>
<%
    // se non ho un contesto,
    // forza una transazione per iniziare....
    FA.startTransactionIfNoUser( request, response, "qm_start", "" );

%>
<%
    // BUNDLES SPECIFICI PER LA PAGINA. VENGONO IMPORTATI IN PAGINA DA 00_page_header.jsp
        String pageBundle = AssetManager.basicBundle(session, application, request);

%>
<%@ include file="/includes/00_page_header.jspf" %>
<%
    // inizializza Decodes

    oDec.load( "masterkeyAbilitato", "masterkey_abilitato.txt", 0, 1 );
    final String stVerbPrefix = "qm_cfg2_qa_forms";
    final String stTabPrefix  = "TABQA_FORMS";
    String stWidth       = "" ;
    String stWidthShort  = "" ;
//    oDec.load( "queueDirection", "queueDirection.txt", 0, 1 );
//    oDec.load( "queueDirectionImg", "queueDirection.txt", 0, 2 );
//    oDec.load( "masterkeyAbilitato", "masterkey_abilitato.txt", 0, 1 );
    ItemsListRenderer listRenderer = new ItemsListRenderer();
%>

<script>
function onLoadApplicativo() {
	// transazione standard
	document.forms[0].<%= K.REQ_VERBO %>.value = "";
	document.forms[0].<%= K.REQ_PARAM %>.value = "";
}
</script>

<div class="qm-form-body L-column L-gap-32">
  <div class="L-row L-justify-spacebetween">
    <h2><%= oDec.k("edit_record_qa_title") %></h2>
    <!------------ Not editable items ---------------->
    <%= LowayHtml.sysFields( oC, oDec, "TABQA_FORMS", "form_id" ) %>
    
  </div>

  <div class="L-grid L-gap-48">
    <div class="left">
      <div class="L-column L-gap-24">
        <div class="L-row L-gap-16">
          <div class="L-column L-gap-8 L-width-50">
            <label for="TABQA_FORMS_nome_form"><%= oDec.k("edit_record_qa_name") %></label>
            <div><%= oH.textBox( "TABQA_FORMS_nome_form",  true, stWidth, 100 ) %></div>
          </div>

          <div class="L-column L-gap-8 L-width-50">
            <label for="TABQA_FORMS_is_locked"><%= oDec.k("edit_record_qa_locked") %></label>
            <div><%= oH.combo( "TABQA_FORMS_is_locked", true, stWidth, oC.getLt( "TABQA_FORMS_lockyesno" ), 0, 1, "n" ) %></div>
          </div>

          <div class="L-column L-gap-8 L-width-50">
          <label for="TABQA_FORMS_seckey_queues"><%= oDec.k("edit_record_qa_visibility") %></label>
          <div><%= oH.textBox( "TABQA_FORMS_seckey_queues", true, stWidth, 500 ) %></div>
        </div>
        </div>

        <div class="L-row L-gap-16">
          <div class="L-column L-gap-8 L-width-50">
            <label for="TABQA_FORMS_seckey_input"><%= oDec.k("edit_record_qa_inputkey") %></label>
            <div><%= oH.textBox( "TABQA_FORMS_seckey_input",  true, stWidth, 100 ) %></div>
          </div>

          <div class="L-column L-gap-8 L-width-50">
            <label for="TABQA_FORMS_seckey_report"><%= oDec.k("edit_record_qa_reportkey") %></label>
            <div><%= oH.textBox( "TABQA_FORMS_seckey_report",  true, stWidth, 100 ) %></div>
          </div>

          <div class="L-row L-gap-8 L-width-50">
            <label for="TABQA_FORMS_howmanyrecords"><%= oDec.k("edit_record_qa_nofgradedcalls") %></label>
            <div><%= oC.getI( "TABQA_FORMS_howmanyrecords" ) %></div>
          </div>
        </div>
      </div>
    </div>

    <div class="right">
      <div class="L-column L-gap-24">
        

       
      </div>
    </div>
  </div>

  <div class="L-column L-gap-24">
    <h3 class="L-heading-divider"><%= oDec.k("edit_record_qa_secnames") %></h3>
    <div class="L-grid-3 L-gap-24">
      <% for (int s = 1; s <= QAFormInfo.MAX_SECTIONS; s++) {
          out.println("<div class=\"L-column L-gap-8\">");
          out.println("<label for=\"TABQA_FORMS_section_"+ s +"\">");
          out.println( oDec.k("edit_record_qa_section") + " " + s );
          out.println("</label>");

          out.println(oH.textBox( "TABQA_FORMS_section_" + s,  true, stWidth, 50 ));
          out.println(listRenderer.RenderList(oC.getLt( "TABQA_FORMS_itemslist_" + s )));
          out.println("</div>");
      } %>
    </div>
  </div>

  <div class="L-column L-gap-24">
    <h3 class="L-heading-divider"><%= oDec.k("edit_record_qa_grading") %></h3>
      <div class="qm-admin-callgrading L-grid-3">
        <% for (int i = 1; i < 5; i++) { %>
          <div class="L-tertiary-text"><%= oDec.k("edit_record_qa_maxvalue") %></div>
          <label class="L-width-50 L-row L-gap-4	" for="TABQA_FORMS_rating_<%=i%>" class="qm-form-second-smaller L-width-50">
            <%= oH.textBox( "TABQA_FORMS_rating_" + i + "_label",  true, stWidth, 50 ) %>
            ( <%= oH.textBox( "TABQA_FORMS_rating_" + i + "_labelshort",  true, stWidthShort, 5 ) %> )
          </label>

          <div class="qm-qa-maxvalue"><%= oH.textBox( "TABQA_FORMS_rating_" + i,  true, stWidthShort, 3 ) %></div>
      <% } %>
      </div>

      <div class="L-row L-justify-spacebetween">
        <%= oH.iconButton( "<span loway-icon='chevron-left'></span>"+oDec.k("edit_record_back"), true, "", stVerbPrefix + "_list", "", "Q-button-tertiary") %>
        <div class="L-row L-gap-16">
          <%= oH.button( oDec.k("edit_record_new"), (oC.getI("TABQA_FORMS_form_id") > 0 ), "", stVerbPrefix + "_edit", "N", "Q-button-secondary") %>
          <%= oH.button( oDec.k("edit_record_clone"), (oC.getI("TABQA_FORMS_form_id") > 0 ), "", stVerbPrefix + "_edit", "C", "Q-button-secondary") %>
          <% boolean boCanModify = (oC.getI("TABQA_FORMS_form_id") > 0 ) && ( oC.getI( "TABQA_FORMS_howmanyrecords" ) == 0); %>
          <%= oH.button( oDec.k("edit_record_qa_editsections"), boCanModify , "", "qm_cfg2_qa_form_items", oC.getS("TABQA_FORMS_form_id"), "Q-button-secondary") %>
          <%= oH.buttonScript( oDec.k("edit_record_delete"), boCanModify, "", "deleteSingleRecord('"+stVerbPrefix+"','"+oC.getS("TABQA_FORMS_nome_form")+"','"+oC.getS("TABQA_FORMS_form_id")+"')", "Q-button-secondary") %>
        </div>
        <%= oH.button( oDec.k("edit_record_save"), true, "", stVerbPrefix + "_edit", "S" ) %>
      </div>
  </div>
</div>

<%@ include file="/includes/00_page_footer.jspf" %>