<%@ page language="java" %>
<%@ page import="it.loway.tpf.*" %>
<%@ page import="it.loway.tpf.common.containers.*" %>
<%@ page import="it.loway.tpf.common.interfaces.*" %>
<%@ page import="it.loway.tpf.common.exceptions.*" %>
<%@ page import="it.loway.tpf.presentation.html.*" %>
<%
    // Per entrare qui faccio
    //     http://localhost:8080/qm/qm_adm/db_props_editor/fullpage.jsp

    // Ho due sotto-pagine:
    //     - props_list.jsp  (la lista delle properties, sulla base del filtro di ricerca)
    //     - prop_details.jsp (il dettaglio di una property)
    //

    // BUNDLES SPECIFICI PER LA PAGINA. VENGONO IMPORTATI IN PAGINA DA 00_page_header.jsp
    String pageBundle = AssetManager.htmxBundle(session, application, request);



%>
<%@ include file="/includes/00_page_header.jspf" %>


<script defer>
function onLoadApplicativo() {
	// transazione standard
	document.forms[0].<%= K.REQ_VERBO %>.value = "";
	document.forms[0].<%= K.REQ_PARAM %>.value = "";
    setFocus( "ED_search" );
htmx.logAll();
}
</script>

<div class="L-column L-gap-24 L-padding-48">
  <h2><%= oDec.k("cfgprops_title") %></h2>
  <div class="L-column L-gap-24">
    <div class="L-row L-justify-spacebetween L-gap-24">
      <div class="L-row L-gap-24 L-align-center">
        <%-- Search line --%>
        <div class="LSearchBar">
          <input 
            class="LSearchBar-input"
            name="ED_search"
            id="ED_search"
            <%= Htmx.quotedParam( request,  "value", "ED_search" ) %>
            placeholder="Search"
            hx-post="./qm_props_editor.do"
            hx-vals='{"TPF_XPAR1": "LIST"}'
            hx-include="[name='ED_sort']"
            hx-trigger="input changed delay:500ms, change from:#sort_date, change from:#sort_name"
            hx-target="#div_current_properties"
            hx-indicator=".htmx-spinner-indicator"
          >
          <span title=" " class="LIcon LIcon-without-padding" role="button" aria-label=" " style="color: rgb(164, 177, 188); border-color: rgb(164, 177, 188); cursor: default;">
            <svg width="18" height="18" viewBox="0 0 20 20" fill="none" xmlns="http://www.w3.org/2000/svg"><path d="M9 16C12.866 16 16 12.866 16 9C16 5.13401 12.866 2 9 2C5.13401 2 2 5.13401 2 9C2 12.866 5.13401 16 9 16Z" stroke="#a4b1bc" stroke-width="1.4" stroke-linejoin="round"></path><path d="M14 14L18 18L14 14Z" stroke="#a4b1bc" stroke-width="1.4" stroke-linejoin="round"></path>
            </svg>
          </span>
        </div>

        <div class="L-row L-gap-8">
          <p class="L-tertiary-text L-text-nowrap" style="margin: 0;">
            <%= oDec.k("cfgprops_sort_by") %>
          </p>
          <div class="L-radio">
            <input type="radio" id="sort_name" name="ED_sort" value="NAME" checked>
            <label for="sort_name" class="radio-label"><%= oDec.k("cfgprops_sort_byname") %></label><br>
          </div>
          <div class="L-radio">
            <input type="radio" id="sort_date" name="ED_sort" value="DATE">
            <label for="sort_date" class="radio-label"><%= oDec.k("cfgprops_sort_bydate") %></label>
          </div>
        </div>

        <%-- New button --%>
        <div>
          <input type="button" class="Q-button-primary" value="<%= oDec.k("art_featureAddBtn") %>"
            <%= Htmx.hxPostWithVals("qm_props_editor", "CHANGE", request, "ED_item=") %>
            hx-target="#page-modal-content"
            hx-swap="innerHTML"
            _="on htmx:afterOnLoad openPageModal()"  >
        </div>

        <%-- Spinner --%>
        <div hx-trigger="load">
          <img alt="Loading..." class="htmx-spinner-indicator" width="24" src="<%= stWebHere %>/img/Q-spinner.svg"/>
        </div>

        <%-- Hidden error --%>
        <%-- 
        <div class="L-width-100">
          <div class="L-error">Error: Lorem ipsum dolor sit amet, consectetur adipiscing elit, sed do eiusmod tempor incididunt.</div>
        </div>
        --%>
      </div>
      <%-- export button --%>
        <a 
          type="button"
          class="Q-button-secondary"
          href="./qm_props_editor.do?EXPORT"
          target="_new"
        >
          <%= oDec.k("rt3_export_schema") %>
        </a>
      </div>
    </div>
    <div class="L-font-14 L-tertiary-text">
      <%= oDec.k("cfgprops_notice") %>
    </div>




    <%@include file="./props_list.jsp" %>
  </div>
</div>


<%@ include file="./htmx_modal.jspf" %>
<%@ include file="/includes/00_page_footer.jspf" %>
<%
//
%>
