<%@ page language="java" %>
<%@ page import="it.loway.tpf.*" %>
<%@ page import="it.loway.tpf.common.containers.*" %>
<%@ page import="it.loway.tpf.common.interfaces.*" %>
<%@ page import="it.loway.tpf.common.exceptions.*" %>
<%@ page import="it.loway.tpf.presentation.html.*" %>
<%@ page import="it.loway.app.queuemetrics.configurazione.cfg2.confkeyhelper.*" %>

<!-- Access this page from Explore System Parameters -->

<%
    // se non ho un contesto,
    // forza una transazione per iniziare....
    FA.startTransactionIfNoUser( request, response, "qm_start", "" );
%>
<%
    // BUNDLES SPECIFICI PER LA PAGINA. VENGONO IMPORTATI IN PAGINA DA 00_page_header.jsp
        String pageBundle = AssetManager.basicBundle(session, application, request);

%>
<%@ include file="/includes/00_page_header.jspf" %>
<%
    //$Id: props_editor_wizard.jsp,v 1.3 2015/09/28 08:41:15 marcos Exp $
%>
<%
class SideBarDecorator {
    public String getSideBar(ConfKeyConfig root) {
        StringBuilder html = new StringBuilder();
        html.append("<div id='sidebar'>");
        html.append("<div id='checkdiv'></div>");
        html.append("<nav class=''>");
        html.append("<ul class='L-column L-gap-16'>");
        String active = "class='active'";
        String divActive = "class='sidebardetaildiv L-column L-gap-8'";
        for (ConfKeyCategory category:root.getCategories()) {
            if ((category != null) &&
                (category.getTitle() != null) &&
                !category.getTitle().isEmpty()) {
                    html.append("<li><a href='#").append(category.getLabel()).append("' ").append(active).append(">");
                    html.append(category.getTitle()).append("</a>");
                    if ((category.getFeatures() != null) && !category.getFeatures().isEmpty()) {
                        html.append("<div ").append(divActive).append(" >");
                        for (ConfKeyFeature feature:category.getFeatures()) {
                            if ((feature.getDescription() != null) && !feature.getDescription().isEmpty()) {
                                html.append("<div>").append(feature.getDescription()).append("</div>");
                            }
                        }
                        html.append("</div>");
                    }
                    html.append("</li>");
                    active = "";
                }
        }
        html.append("</ul>");
        html.append("</nav>");
        html.append("</div>");
        return html.toString();
    }
}
class SecKeysDecoratorHelper {
    public SecKeysDecoratorHelper() {
    }
    public String getCategoryMainTitle(ConfKeyCategory category) {
        if ((category != null) &&
                (category.getTitle() != null) &&
                !category.getTitle().isEmpty()) {
            return "<h3>" + category.getTitle() + "</h3>";
        }
        return "";
    }
    public String getKeyOptionGui(ConfKey key) {
        StringBuilder html = new StringBuilder();
        String itemBaseId = getKeyBaseId(key);
        // Render a select
        if(( key.getContextTable() != null )&&(key.getContextTable().length() > 0)){
            String defValue = key.getDefaultVal();
            String curVal = key.getCurrentVal();
            html.append("<select class='qm-input Input optionselect' id='item_").append(itemBaseId).append("' name='item_").append(itemBaseId).append("' ");
            html.append("onchange='javascript:onOptionSelection(\"").append(itemBaseId).append("\", ").append(getAsJSArray(key.getOptionDescriptions())).append(")'");
            html.append(">");
            for (int n = 0; n < key.getOptionLabels().size(); n++) {
                String keyVal = key.getOptionValues().get(n);
                String keyDesc = key.getOptionLabels().get(n);
                String defaultMarker = ((defValue.compareToIgnoreCase(keyVal) == 0)? " (*) " : "");
                String currentMarker = ((curVal.compareToIgnoreCase(keyVal) == 0)? " selected " : "");
                html.append("<option value='").append(keyVal).append("'").append(currentMarker).append(">").append(defaultMarker).append(keyDesc).append("</option>");
            }
            html.append("</select>");
        } else if ((key.getOptionLabels() != null) && (key.getOptionDescriptions() != null) && !key.getOptionLabels().isEmpty()) {
            String defValue = key.getDefaultVal();
            String curVal = key.getCurrentVal();
            html.append("<select class='qm-input Input optionselect' id='item_").append(itemBaseId).append("' name='item_").append(itemBaseId).append("' ");
            html.append("onchange='javascript:onOptionSelection(\"").append(itemBaseId).append("\", ").append(getAsJSArray(key.getOptionDescriptions())).append(")'");
            html.append(">");
            for (int n = 0; n < key.getOptionLabels().size(); n++) {
                String keyVal = key.getOptionValues().get(n);
                String keyDesc = key.getOptionLabels().get(n);
                String defaultMarker = ((defValue.compareToIgnoreCase(keyVal) == 0)? " (*) " : "");
                String currentMarker = ((curVal.compareToIgnoreCase(keyVal) == 0)? " selected " : "");
                html.append("<option value='").append(keyVal).append("'").append(currentMarker).append(">").append(defaultMarker).append(keyDesc).append("</option>");
            }
            html.append("</select>");
        } else {
            // Render a free text
            String curVal = " value='" + key.getCurrentVal() + "' ";
            String onChange = "";
            try {
                int minVal = Integer.parseInt(key.getMinVal());
                int maxVal = Integer.parseInt(key.getMaxVal());
                if ((minVal != 0) || (maxVal != 0)) {
                    onChange = " onkeyup='javascript:onFreeTextChange(\"" + itemBaseId + "\" ," + minVal + "," + maxVal + ")' ";
                }
            } catch (NumberFormatException ex) {
            }
            html.append("<input class='qm-input Input optionfreetext' id='item_").append(itemBaseId).append("' name='item_").append(itemBaseId).append("'").append(curVal).append(onChange).append("/>");
        }
        return html.toString();
    }

    public String getKeyOptionDescriptionPanel(ConfKey key) {
        String itemBaseId = getKeyBaseId(key);
        StringBuilder html = new StringBuilder();
        html.append("<span id='desc_").append(itemBaseId).append("'>");
        // Key needs a selector
        if ((key.getOptionLabels() != null) && (key.getOptionDescriptions() != null) && !key.getOptionLabels().isEmpty()) {
            String curVal = key.getCurrentVal();
            String curDescription = "";
            for (int n = 0; n < key.getOptionValues().size(); n++) {
                String keyVal = key.getOptionValues().get(n);
                if (curVal.compareToIgnoreCase(keyVal) == 0) {
                    curDescription = key.getOptionDescriptions().get(n);
                }
            }
            html.append(curDescription).append("</span>");
        } else {
            html.append("</span>");
        }
        return html.toString();
    }
    public String getKeyNamePanel(ConfKey key) {
        String itemBaseId = getKeyBaseId(key);
        StringBuilder html = new StringBuilder();
        html.append("<span id='propName_").append(itemBaseId).append("'>");
        // Key needs a selector
        if ((key.getName() != null)) {
            String name = key.getName();
            html.append(name).append("</span>");
        } else {
            html.append("</span>");
        }
        return html.toString();
    }
    public String getKeySearchableInfoPanel(ConfKeyFeature feature, ConfKey key) {
        String featureId = feature.getLabel();
        String itemBaseId = getKeyBaseId(key);
        StringBuffer sb = new StringBuffer();
        sb.append("<div class='keysearchcontents' id='src_").append(featureId).append("_").append(itemBaseId).append("'>");
        sb.append(key.getSearchableContent());
        sb.append("</div>");
        return sb.toString();
    }
    public String getKeyBaseId(ConfKey key) {
        String itemBaseId = key.getName().replace(".", "_");
        return itemBaseId;
    }
    public String getKeyMeasureUnit(ConfKey key){
        String unitOfMeasure = key.getUnitOfMeasure();
        return unitOfMeasure;
    }
    private String getAsJSArray(List<String> array) {
       StringBuilder sb = new StringBuilder();
       sb.append("[ ");
       for (int n = 0; n < array.size(); n++) {
           sb.append("\"").append(array.get(n)).append("\"");
           if (n != (array.size() - 1)) {
               sb.append(",");
           }
       }
       sb.append(" ]");
       return sb.toString();
    };
}


    // sempre editabile - è sul DB
    boolean boEditable = true;
    String errMsg  = oC.getS( "CONFIG_error" );
    String comment = oC.getS( "CONFIG_comment" );
    ConfKeyConfig configInfo = (ConfKeyConfig)oC.get("CONFIG_CONFTREEINFO");
    SideBarDecorator sideBarDecorator = new SideBarDecorator();
%>

<script>

var page_props_editor_wizard = true;
var boEditable = <%= (boEditable)? "true":"false"%>;

function onLoadApplicativo() {
    // transazione standard
    document.forms[0].<%= K.REQ_VERBO %>.value = "";
    document.forms[0].<%= K.REQ_PARAM %>.value = "";
}
</script>

<div class="L-column L-gap-24 L-padding-48">
  <h2><%= oDec.k("cfgprops_title_wizard") %></h2>
  <div class="L-tertiary-text"> <small><%= oDec.k("cfgprops_notice") %></small> </div>

  <!-- search menu -->
  <div class="qm-sticky-searchtoolcontainer L-row L-justify-spacebetween" loway-sticky>
    <%-- Back button --%>
    <%= oH.iconButton( "<span loway-icon='chevron-left'></span>"+oDec.k("editor_back"), true, "", "qm_start", "", "Q-button-tertiary") %>
    
    <div class="L-row L-gap-24">
    <%-- Search --%>
      <div class="LSearchBar">
        <input type="text" class="LSearchBar-input" id="searchbox" placeholder="Search" <%-- onKeyup="javascript:onSearchKeyUp()" --%>/>
        <span title=" " class="LIcon LIcon-without-padding" role="button" aria-label=" " style="color: rgb(164, 177, 188); border-color: rgb(164, 177, 188); cursor: default;">
          <svg width="18" height="18" viewBox="0 0 20 20" fill="none" xmlns="http://www.w3.org/2000/svg"><path d="M9 16C12.866 16 16 12.866 16 9C16 5.13401 12.866 2 9 2C5.13401 2 2 5.13401 2 9C2 12.866 5.13401 16 9 16Z" stroke="#a4b1bc" stroke-width="1.4" stroke-linejoin="round"></path><path d="M14 14L18 18L14 14Z" stroke="#a4b1bc" stroke-width="1.4" stroke-linejoin="round"></path>
          </svg>
        </span>
      </div>
      <%-- Save button --%>
      <%= oH.button(oDec.k("editor_save"), boEditable, "", "qm_props_editor_wizard", "S" ) %>
    </div>
  </div>

  <div id="keypagecontainer">
    <div class="L-row L-gap-64 L-align-flexstart">
  
      <!-- sidebar -->
      <div class="qm-grid-placeholder qm-propeditor-sidebar-container" >
        <div class="qm-propeditor-sidebar" loway-sticky="top: 111, left: 48">
        <%= sideBarDecorator.getSideBar(configInfo) %>
        </div>
      </div>
  
      <div class="qm-grid-placeholder L-width-100">
        <div id="keycontents" class="L-column L-gap-48">
  
          <% if (configInfo != null) {
              for (ConfKeyCategory category:configInfo.getCategories()) {
                  SecKeysDecoratorHelper decoratorHelper = new SecKeysDecoratorHelper();
          %>
  
          <section class="sectionCategory L-column L-gap-24" id="<%= category.getLabel() %>">
            <div class="confKeyCategory">
              <%= decoratorHelper.getCategoryMainTitle(category) %>
            </div>
  
            <div class="confKeyContents L-width-100 L-column L-gap-24">
              <% for (ConfKeyFeature feature:category.getFeatures()) { %>
              <div class="L-column L-gap-24" class="confKeyFeatureContent">
                <h4 class="featDescription L-heading-divider" id="confFeat_<%= feature.getLabel() %>"><%= feature.getDescription() %></h4>

                <div class="keyDescriptionContent L-column L-gap-24">
                    <% for (ConfKey key:feature.getKeys()) { %>
                    <div class="keyDescriptionRow L-grid L-gap-16" id="keyRow_<%= decoratorHelper.getKeyBaseId(key) %>">
                      <div class="keyDescription L-width-100"  <%-- onmouseover="showPropertyName(this)" onmouseout="hidePropertyName(this)" --%> >
                        <%= key.getDescription() %>
                        <!-- parameter name -->
                        <div class="keyName"  ><%= decoratorHelper.getKeyNamePanel(key) %></div>
                      </div>
  
                      <div class="keyOptionGui L-row L-width-100">
                        <%= decoratorHelper.getKeyOptionGui(key) %>
                          <span class="unitOfMeasure "><%=decoratorHelper.getKeyMeasureUnit(key) %></span>
                          <div class="keyOptionDescription"> <%= decoratorHelper.getKeyOptionDescriptionPanel(key) %> </div>
                      </div>
                </div>

                <%= decoratorHelper.getKeySearchableInfoPanel(feature, key) %>
                
                <% } %>
                </div>
              </div>
            <% } %>
          </div>
        </section>
  
      <% }
      } %>
        </div>
      </div>
    </div>
  </div>

  <div style="margin-top: 20px;">
    <% if ( errMsg.length() > 0 ) { %>
    <p class="L-font-14 L-error">
      <b>Error:</b> <br>
      <%= errMsg %>
    </p>

    <% } else

    if ( comment.length() > 0 ) { %>
      <p class="L-font-14 L-tertiary-text"><%= comment %></p>
      <% } %>
  </div>

  <input type="hidden" name="CONFIG_CONFIGOPTILOCK" value="<%= oC.getS("CONFIG_CONFIGOPTILOCK") %>"/>
</div>

<%@ include file="/includes/00_page_footer.jspf" %>
