<%@ page language="java" %>
<%@ page import="it.loway.tpf.*" %>
<%@ page import="it.loway.tpf.common.containers.*" %>
<%@ page import="it.loway.tpf.common.interfaces.*" %>
<%@ page import="it.loway.tpf.common.exceptions.*" %>
<%@ page import="it.loway.tpf.presentation.html.*" %>
<%@ page import="it.loway.tpf.presentation.html.decorators.*" %>
<%@ page import="it.loway.app.queuemetrics.autenticazione.*" %>
<%@ page import="java.util.*" %>
<%
    // se non ho un contesto,
    // forza una transazione per iniziare....
    FA.startTransactionIfNoUser( request, response, "qm_start", "" );
    class syslogActionDecor implements TpfCellDecoratorInterface {
        public String decorate(LTable lt, int r, int c, String width) throws TechException {
            String stResult = lt.getS(r, c);
            int iAction = lt.getI(r, c);
            /* Properly decode the action Id */
            stResult = SysLog.decodeActionId(iAction, stResult);
            return "<td class='stData' style='width: " + width + "; '>" + stResult + "</td>";
        }
    };
    class userDecor implements TpfCellDecoratorInterface {
        public String decorate(LTable lt, int r, int c, String width) throws TechException {
            String stResult = lt.getS(r, c);

            if(stResult.equals("0")){
                stResult = "-";
            }

            return "<td class='stData' style='width: " + width + "; '>" + stResult + "</td>";
        }
    };

    class shortenSessionDecor implements TpfCellDecoratorInterface {
        public String decorate(LTable lt, int r, int c, String width) throws TechException {
            String stResult = lt.getS(r, c);
            String newResult = stResult;
            int l = stResult.length();

            if ( l> 12 ) {
                newResult = stResult.substring(0,6)
                          + "..."
                          + stResult.substring(l-6, l);
            }

            return "<td class='stData' style='width: " + width + "; '>" + newResult + "</td>";
        }
    };


%>
<%
    // BUNDLES SPECIFICI PER LA PAGINA. VENGONO IMPORTATI IN PAGINA DA 00_page_header.jsp
        String pageBundle = AssetManager.basicBundle(session, application, request);

%>
<%@ include file="/includes/00_page_header.jspf" %>


<script>
function onLoadApplicativo() {
    // transazione standard
    document.forms[0].<%= K.REQ_VERBO %>.value = "";
    document.forms[0].<%= K.REQ_PARAM %>.value = "";
    //$("#SYSREP_logDtStart_date").datepicker({dateFormat: 'yy-mm-dd'});
    //$("#SYSREP_logDtEnd_date").datepicker({dateFormat: 'yy-mm-dd'});

    //$("#searchbox").val($("#SYSREP_query").val());
};

var page_show_auditlog_info = true;
var setFocusPath = "searchbox";
var stVerbPrefix = "qm_syslogInfoShow";
</script>


<div class="qm-form-body L-column L-gap-24">
  <div class="L-row L-justify-spacebetween">
    <h2><%=CS.QUEUEMETRICS%> System Log</h2>

    <div class="L-row L-gap-16">
      <div class="LSearchBar">
        <input id="SYSREP_query" name="SYSREP_query" class="LSearchBar-input" type="search" placeholder="<%=oDec.k("tsk_lists_search")%>" value="<%=XssFilter.encodeToHtml(oC.getS("SYSREP_query"))%>">
        <span title=" " class="LIcon LIcon-without-padding" role="button" aria-label=" " style="color: rgb(164, 177, 188); border-color: rgb(164, 177, 188); cursor: default;">
          <svg width="18" height="18" viewBox="0 0 20 20" fill="none" xmlns="http://www.w3.org/2000/svg"><path d="M9 16C12.866 16 16 12.866 16 9C16 5.13401 12.866 2 9 2C5.13401 2 2 5.13401 2 9C2 12.866 5.13401 16 9 16Z" stroke="#a4b1bc" stroke-width="1.4" stroke-linejoin="round"></path><path d="M14 14L18 18L14 14Z" stroke="#a4b1bc" stroke-width="1.4" stroke-linejoin="round"></path>
          </svg>
        </span>
      </div>
    </div>
  </div>

  <div class="L-row L-gap-16 L-justify-spacebetween L-align-flexend">
    <div class="L-column L-gap-8 L-width-25">
      <label for="SYSREP_filter"><%= oDec.k("clhdr_filter") %></label>
      <div><%= oH.combo( "SYSREP_filter", true, "", SysLog.actionsCategoriesAsLTable() , 2, 1, "" ) %></div>
    </div>
      
    <div class="L-row L-gap-16">
      <div class="L-column L-gap-8">
        <label for="SYSREP_logDtStart_date"><%= oDec.k("clhdr_period_start_date") %></label>
        <div class="qm-form-datehourpicker">
          <%= FA.generaJQueryComboDataOra( "SYSREP_logDtStart", oC,oH,true, oDec) %>      
        </div>
      </div>

      <div class="L-column L-gap-8">
        <label for="SYSREP_logDtEnd_date"><%= oDec.k("clhdr_period_end_date") %></label>
        <div class="qm-form-datehourpicker"><%= FA.generaJQueryComboDataOra( "SYSREP_logDtEnd", oC,oH,true, oDec) %></div>
      </div>
    </div>

    <div class="qm-editor-button L-flexend"><%= oH.button( oDec.k("qa_report_data"), true, "", "qm_syslogInfoShow", "QALL" ) %></div>
  </div>


    <%
    LTable ltD = oC.getLt("SYSREP_ltLogs");
    SmartTable stT = new SmartTable( "x", ltD );
    stT.addColumn( "Date",        0   , "120");
    stT.addColumn( "User",        1   , "80");
    stT.addColumn( "Session",     2   , "100", new shortenSessionDecor());
    stT.addColumn( "Action",      3   , "100", new syslogActionDecor());
    stT.addColumn( "Text 1",      4   , "100");
    stT.addColumn( "Text 2",      5   , "100");
    stT.addColumn( "Text 3",      6   , "100");
    stT.addColumn( "Text 4",      7   , "100");
    if ( stT.numRows() > 0 ) {
      stT.withTableClass( "qm-table Q-table Q-table-divider qm-table-striped" );
      out.println( stT.render() );
    }
    if ( stT.getNRigheTotaliQuery() == 0 ) {
      %>
      <%@ include file="/includes/qm_adm/30_qm_adm_noresultsbox.jspf" %>
      <%
    } else { // ci sono righe
      %>
      
      <div class="L-row L-justify-spacebetween">
        <div class="L-tertiary-text L-row L-justify-flexstart">Items found: <%= stT.getNRigheTotaliQuery() %></div>
        <div class="L-tertiary-text L-row L-justify-flexend L-gap-16">
          <% out.println(LowayHtml.secondaryButton("<span loway-icon='chevron-left'></span>", stT.hasPreviousPage(), "qm_syslogInfoShow", "P")); %>
          <% out.println(LowayHtml.secondaryButton("<span loway-icon='chevron-right'></span>", stT.hasNextPage(), "qm_syslogInfoShow", "N")); %>
        </div>

        <div class="L-tertiary-text">Page <%= stT.getPaginaCorrenteQuery() %> of <%= stT.getNPagineTotaliQuery() %></div>
      </div>
      <% } %>
  </div>
</div>
    
  
  
  
  

<%@ include file="/includes/00_page_footer.jspf" %>
<%
//
%>
